SystemOrganization addCategory: #'CodeModel-Iterators'!
SystemOrganization addCategory: #'CodeModel-Model'!
SystemOrganization addCategory: #'CodeModel-Parser'!
SystemOrganization addCategory: #'CodeModel-Tests'!
SystemOrganization addCategory: #'CodeModel-Utilities'!

SmaCCParser subclass: #CMParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Parser'!

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
value: nodes

	^ nodes first value! !

!CMParser class methodsFor: 'generated-comments' stamp: 'cwp 5/26/2004 11:52'!
parserDefinitionComment

	"%id <name> <negativeNumber> <binarySymbol>;
%start Sequence MethodPattern Annotations;

Method:
	MethodPattern Sequence						{#method:}
|	MethodPattern Annotations Sequence			{#methodPrim:}
|	MethodPattern Temporaries Annotations Statements {#methodTempsPrim:};

MethodPattern:
	<name>										{#unaryMessage:}
|	<binarySymbol> Argument					{#messagePart:}
|	KeywordMethodPattern						{#first:};

KeywordMethodPattern:
	<keyword> Argument							{#messagePart:}
|	KeywordMethodPattern <keyword> Argument	{#addMessagePart:};

Annotations:
	Annotation									{#firstIn:}
|	Annotations Annotation						{#add:};

Annotation:
	""<"" KeywordMessage "">""						{#primitiveMessage:};

Sequence:
	Statements									{#sequence:}
|	Temporaries Statements						{#sequenceWithTemps:};

Temporaries:
	""||""											
|	""|"" TemporaryVariables ""|"";

TemporaryVariables:
												{#array}
|	TemporaryVariables Variable				{#add:};

Statements:
												
|	StatementList "".""?							
|	StatementList ""."" ""^"" Expression "".""?			{#returnAdd:}
|	""^"" Expression "".""?							{#return:};

StatementList:
	Expression									{#firstIn:}
|	StatementList ""."" Expression					{#expressionAdd:};

Block:
	""["" BlockArgs ""|"" Sequence ""]""					{#blockWithArgs:}
|	""["" Sequence ""]""								{#blockNoArgs:}
|	""["" BlockArgs ""]""								{#blockArgs:}
|	""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"" {#blockWithTemps:};

BlockArgs:
	"":"" Argument								{#colonAdd:}
|	BlockArgs "":"" Argument						{#argumentAdd:};

Expression:
	Assignment									{#first:}
|	Cascade										{#first:}
|	Primary									{#first:};

Primary:
	""("" Expression "")""								{#parenthesize:}
|	Array										{#first:}
|	Block										{#first:}
|	Literal										{#first:}
|	Variable									{#first:};

Assignment:
	Variable <assignment> Expression				{#assignment:};

Cascade:
	MessageSend								{#first:}
|	Cascade "";"" Message							{#cascade:};

MessageSend:
	KeywordMessageSend						{#first:}
|	BinaryMessageSend							{#first:}
|	UnaryMessageSend							{#first:};

Message:
	UnaryMessage								{#first:}
|	BinaryMessage								{#first:}
|	KeywordMessage							{#first:};

KeywordMessageSend:
	BinaryMessageSend KeywordMessage			{#messageSend:}
|	UnaryMessageSend KeywordMessage			{#messageSend:}
|	Primary KeywordMessage					{#messageSend:};

KeywordMessage:
	<keyword> KeywordArgument				{#messagePart:}
|	KeywordMessage <keyword> KeywordArgument {#addMessagePart:};

KeywordArgument:
	BinaryMessageSend							{#first:}
|	UnaryMessageSend							{#first:}
|	Primary									{#first:};

BinaryMessageSend:
	BinaryMessageSend BinaryMessage			{#messageSend:}
|	UnaryMessageSend BinaryMessage			{#messageSend:}
|	Primary BinaryMessage						{#messageSend:};

BinaryMessage :
	<binarySymbol> BinaryArgument				{#messagePart:};

BinaryArgument:
	UnaryMessageSend							{#first:}
|	Primary									{#first:};

UnaryMessageSend :
	UnaryMessageSend UnaryMessage			{#messageSend:}
|	Primary UnaryMessage						{#messageSend:};

UnaryMessage :
	<name>										{#unaryMessage:};

Array:
	""{"" Statements ""}""								{#array:};

Variable: 
	<name>										{#variable:};

Argument:
	<name>										{#argument:};

Literal:
	""true""										{#litTrue:}
|	""false""										{#litFalse:}
|	""nil""										{#litNil:}
|	<number>									{#litNumber:}
|	<negativeNumber>							{#litNumber:} 
|	<character>									{#litChar:}
|	<string>										{#litString:}
|	""#"" <string>									{#litStringSymbol:}
|	""#"" <name>									{#litSymbol:}
|	""#"" <binarySymbol>							{#litSymbol:}
|	""#"" <keyword>								{#litSymbol:}
|	""#"" <multikeyword>							{#litSymbol:}
|	""#"" <alternateKeyword>						{#litSymbol:}
|	""#"" ""["" ByteArray ""]""							{#litArray:}
|	""#"" ""("" LiteralArray "")""						{#litArray:};

ByteArray:
												{#byteStream}
|	ByteArray <number>							{#byteStreamPut:};

LiteralArray:
												{#stream}
|	LiteralArray ArrayLiteral					{#streamPut:};

ArrayLiteral:
	Literal										{#value:}
|	<name>										{#valueSymbol:}
|	<binarySymbol>								{#valueSymbol:}
|	<keyword>									{#valueSymbol:}
|	<multikeyword>								{#valueSymbol:}
|	<alternateKeyword>							{#valueSymbol:}
|	""("" LiteralArray "")""							{#contents2:}
|	""["" ByteArray ""]""							{#contents2:}
|	<anyChar>									{#valueSymbol:};

"! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 11:08'!
firstIn: nodes
	^ OrderedCollection with: nodes first! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 15:28'!
blockWithTemps: nodes
	"This production rule ensures that '[:arg || temp | statement]' will parse correctly. It's
	necessary because the scanner treats the '||' as a single token - necessary for binary
	selectors. So here we manually split it up into two tokens, and pass the nodes along
	to the ordinary production rules."
	
	| left right subset body |
	left _ CMToken id: nodes third id value: '|' whitespace: nodes third whitespace.
	right _ CMToken id: nodes third id value: '|' whitespace: ''.
	
	"create the node structure that #sequenceWithTemps expects"
	subset _ OrderedCollection new.
	subset 
		add: right;
		add: nodes fourth;
		add: nodes fifth.
	subset _ OrderedCollection with: subset.
	subset add: nodes sixth.
	body _ self sequenceWithTemps: subset.
	
	"create the node structure that #blockWithArgs: expects"
	subset _ nodes first: 2.
	subset 
		add: left;
		add: body;
		add: nodes seventh.
	
	^ self blockWithArgs: subset
! !

!CMParser class methodsFor: 'generated-starting states' stamp: 'cwp 5/26/2004 11:52'!
startingStateForMethod
	^1! !

!CMParser class methodsFor: 'generated-accessing' stamp: 'cwp 5/26/2004 11:52'!
scannerClass
	^CMScanner! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 14:49'!
litStringSymbol: nodes

	| s |
	s _ nodes second value.
	^ CMLiteral
		token: nodes second
		value: ((s copyFrom: 2 to: s size - 1)
				copyReplaceAll: '''''' with: '''') asSymbol! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 11:08'!
returnAdd: nodes
	| statements |
	statements _ nodes first.
	statements add: nodes second.
	statements add: (CMReturn return: nodes third value: nodes fourth).
	nodes size > 4 ifTrue: [statements add: nodes fifth].
	^ statements! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 14:13'!
litFalse: nodes

	^ CMLiteral
		token: nodes first
		value: false! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 14:05'!
variable: nodes

	^ CMVariableReference new
		identifier: nodes first! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/26/2004 11:51'!
methodPrim: nodes

	^ CMMethod
		selectorParts: nodes first first
		arguments: nodes first last
		annotations: nodes second
		body: nodes third! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 11:38'!
expressionAdd: nodes
	| tokens |
	tokens _ nodes first.
	tokens 
		add: nodes second;
		add: nodes third.
	^ tokens! !

!CMParser class methodsFor: 'generated-comments' stamp: 'cwp 5/26/2004 11:52'!
symbolComment

	"
1. ""^""
2. ""[""
3. ""|""
4. ""#""
5. ""]""
6. ""<""
7. "">""
8. ""||""
9. "".""
10. "":""
11. ""false""
12. ""nil""
13. ""true""
14. ""(""
15. ""}""
16. ""{""
17. "")""
18. "";""
19. <number>
20. <negativeNumber>
21. <string>
22. <name>
23. <keyword>
24. <multikeyword>
25. <binarySymbol>
26. <assignment>
27. <alternateKeyword>
28. <whitespace>
29. <comment>
30. <character>
31. <anyChar>
32. Annotation
33. KeywordMessage
34. Method
35. Variable
36. StatementList
37. Optional: "".""
38. Expression
39. BlockArgs
40. Block
41. Assignment
42. Cascade
43. Primary
44. Array
45. Literal
46. B e g i n
47. MessageSend
48. Message
49. KeywordMessageSend
50. BinaryMessageSend
51. UnaryMessageSend
52. UnaryMessage
53. BinaryMessage
54. KeywordArgument
55. BinaryArgument
56. Temporaries
57. KeywordMethodPattern
58. Annotations
59. MethodPattern
60. Sequence
61. ByteArray
62. LiteralArray
63. ArrayLiteral
64. Statements
65. E O F
66. error
67. Argument
68. TemporaryVariables
"! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 19:32'!
assignment: nodes

	^ CMAssignment
		variable: nodes first
		operator: nodes second
		value: nodes third! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/26/2004 11:17'!
primitiveMessage: nodes
	^ (CMAnnotation selectorParts: nodes second first arguments: nodes second second)
			leftParen: nodes first rightParen: nodes third! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 14:57'!
blockWithArgs: nodes

	^ (CMBlock
		arguments: nodes second
		body: nodes fourth)
			leftBracket: nodes first rightBracket: nodes fifth;
			bar: nodes third! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 11:50'!
sequence: nodes
	^ self 
		divideStatements: nodes first
		in: [:s :p | CMSequence statements: s periods: p]! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 15:39'!
parenthesize: nodes
	nodes second leftParen: nodes first rightParen: nodes third.
	^ nodes second! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
unaryMessage: nodes

	^ {{nodes first}. #()}! !

!CMParser methodsFor: 'generated-tables' stamp: 'cwp 5/26/2004 11:52'!
reduceTable
	^#(
#(32 3 #primitiveMessage:)
#(33 2 #messagePart:)
#(33 3 #addMessagePart:)
#(34 2 #method:)
#(34 3 #methodPrim:)
#(34 4 #methodTempsPrim:)
#(35 1 #variable:)
#(36 1 #firstIn:)
#(36 3 #expressionAdd:)
#(37 0 #reduceActionForOptionalXXXXX1:)
#(37 1 #reduceActionForOptionalXXXXX2:)
#(38 1 #first:)
#(38 1 #first:)
#(38 1 #first:)
#(39 2 #colonAdd:)
#(39 3 #argumentAdd:)
#(40 5 #blockWithArgs:)
#(40 3 #blockNoArgs:)
#(40 3 #blockArgs:)
#(40 7 #blockWithTemps:)
#(41 3 #assignment:)
#(42 1 #first:)
#(42 3 #cascade:)
#(43 3 #parenthesize:)
#(43 1 #first:)
#(43 1 #first:)
#(43 1 #first:)
#(43 1 #first:)
#(44 3 #array:)
#(45 1 #litTrue:)
#(45 1 #litFalse:)
#(45 1 #litNil:)
#(45 1 #litNumber:)
#(45 1 #litNumber:)
#(45 1 #litChar:)
#(45 1 #litString:)
#(45 2 #litStringSymbol:)
#(45 2 #litSymbol:)
#(45 2 #litSymbol:)
#(45 2 #litSymbol:)
#(45 2 #litSymbol:)
#(45 2 #litSymbol:)
#(45 4 #litArray:)
#(45 4 #litArray:)
#(46 1 #reduceFor:)
#(47 1 #first:)
#(47 1 #first:)
#(47 1 #first:)
#(48 1 #first:)
#(48 1 #first:)
#(48 1 #first:)
#(49 2 #messageSend:)
#(49 2 #messageSend:)
#(49 2 #messageSend:)
#(50 2 #messageSend:)
#(50 2 #messageSend:)
#(50 2 #messageSend:)
#(51 2 #messageSend:)
#(51 2 #messageSend:)
#(52 1 #unaryMessage:)
#(53 2 #messagePart:)
#(54 1 #first:)
#(54 1 #first:)
#(54 1 #first:)
#(55 1 #first:)
#(55 1 #first:)
#(56 1 #reduceFor:)
#(56 3 #reduceFor:)
#(57 2 #messagePart:)
#(57 3 #addMessagePart:)
#(58 1 #firstIn:)
#(58 2 #add:)
#(59 1 #unaryMessage:)
#(59 2 #messagePart:)
#(59 1 #first:)
#(60 1 #sequence:)
#(60 2 #sequenceWithTemps:)
#(61 0 #byteStream)
#(61 2 #byteStreamPut:)
#(62 0 #stream)
#(62 2 #streamPut:)
#(63 1 #value:)
#(63 1 #valueSymbol:)
#(63 1 #valueSymbol:)
#(63 1 #valueSymbol:)
#(63 1 #valueSymbol:)
#(63 1 #valueSymbol:)
#(63 3 #contents2:)
#(63 3 #contents2:)
#(63 1 #valueSymbol:)
#(64 0 #reduceFor:)
#(64 2 #reduceFor:)
#(64 5 #returnAdd:)
#(64 3 #return:)
#(67 1 #argument:)
#(68 0 #array)
#(68 2 #add:)
)! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 14:43'!
litTrue: nodes

	^ CMLiteral
		token: nodes first
		value: true! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
addMessagePart: nodes

	^ {nodes first first copyWith: nodes second.
	   nodes first second copyWith: nodes third}! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 14:29'!
argument: nodes
	^ CMArgument identifier: nodes first! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 14:38'!
argumentAdd: nodes
	| arguments |
	arguments _ nodes first.
	arguments add: nodes third.
	arguments last colon: nodes second.
	^ arguments! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
streamPut: nodes

	^ nodes first
		nextPut: nodes second;
		yourself! !

!CMParser class methodsFor: 'parsing' stamp: 'cwp 5/23/2004 22:44'!
parseMethod: aString
	^ self parse: aString startingAt: self startingStateForMethod ! !

!CMParser methodsFor: 'generated-tables' stamp: 'cwp 5/26/2004 11:52'!
transitionTable
	^#(
#(3 21 22 25 23 29 25 33 34 37 57 41 59)
#(3 45 1 49 2 53 3 57 4 61 8 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 105 35 109 36 113 38 117 40 121 41 125 42 129 43 133 44 137 45 141 47 145 49 149 50 153 51 157 56 161 60 165 64 366 65)
#(3 21 22 25 23 29 25 37 57 169 59)
#(3 173 6 177 32 181 58)
#(2 294 1 2 3 4 6 8 11 12 13 14 16 19 20 21 22 30 65)
#(3 185 22 189 67)
#(3 185 22 193 67)
#(2 0 65)
#(3 302 1 302 2 302 3 302 4 302 6 302 8 302 11 302 12 302 13 302 14 302 16 302 19 302 20 302 21 302 22 197 23 302 30 302 65)
#(3 45 1 49 2 53 3 57 4 173 6 61 8 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 177 32 105 35 109 36 113 38 117 40 121 41 125 42 129 43 133 44 137 45 141 47 145 49 149 50 153 51 201 56 205 58 209 60 165 64 366 65)
#(3 49 2 57 4 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 105 35 213 38 117 40 121 41 125 42 129 43 133 44 137 45 141 47 145 49 149 50 153 51)
#(3 45 1 49 2 53 3 57 4 366 5 61 8 217 10 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 105 35 109 36 113 38 221 39 117 40 121 41 125 42 129 43 133 44 137 45 141 47 145 49 149 50 153 51 157 56 225 60 165 64)
#(3 386 3 386 22 229 68)
#(3 233 2 237 14 241 21 245 22 249 23 253 24 257 25 261 27)
#(2 270 1 2 4 5 6 11 12 13 14 16 19 20 21 22 30 65)
#(2 126 2 4 5 7 9 11 12 13 14 15 17 18 19 20 21 22 23 24 25 27 30 31 65)
#(2 130 2 4 5 7 9 11 12 13 14 15 17 18 19 20 21 22 23 24 25 27 30 31 65)
#(2 122 2 4 5 7 9 11 12 13 14 15 17 18 19 20 21 22 23 24 25 27 30 31 65)
#(3 49 2 57 4 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 105 35 265 38 117 40 121 41 125 42 129 43 133 44 137 45 141 47 145 49 149 50 153 51)
#(3 45 1 49 2 57 4 65 11 69 12 73 13 77 14 366 15 81 16 85 19 89 20 93 21 97 22 101 30 105 35 109 36 113 38 117 40 121 41 125 42 129 43 133 44 137 45 141 47 145 49 149 50 153 51 269 64)
#(2 134 2 4 5 7 9 11 12 13 14 15 17 18 19 20 21 22 23 24 25 27 30 31 65)
#(2 138 2 4 5 7 9 11 12 13 14 15 17 18 19 20 21 22 23 24 25 27 30 31 65)
#(2 146 2 4 5 7 9 11 12 13 14 15 17 18 19 20 21 22 23 24 25 27 30 31 65)
#(2 30 3 5 7 9 15 17 18 22 23 25 26 65)
#(2 142 2 4 5 7 9 11 12 13 14 15 17 18 19 20 21 22 23 24 25 27 30 31 65)
#(3 114 5 114 9 114 15 114 17 114 22 114 23 114 25 273 26 114 65)
#(3 42 5 277 9 42 15 281 37 42 65)
#(2 34 5 9 15 65)
#(2 106 5 7 9 15 17 18 22 23 25 65)
#(2 50 5 9 15 17 65)
#(3 54 5 54 9 54 15 54 17 285 18 54 65)
#(3 58 5 58 9 58 15 58 17 289 22 293 23 297 25 301 33 305 52 309 53 58 65)
#(2 102 5 7 9 15 17 18 22 23 25 65)
#(2 110 5 7 9 15 17 18 22 23 25 65)
#(2 90 5 9 15 17 18 65)
#(2 186 5 9 15 17 18 65)
#(3 190 5 190 9 190 15 190 17 190 18 293 23 297 25 313 33 317 53 190 65)
#(3 194 5 194 9 194 15 194 17 194 18 289 22 293 23 297 25 321 33 325 52 329 53 194 65)
#(3 45 1 49 2 57 4 366 5 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 105 35 109 36 113 38 117 40 121 41 125 42 129 43 133 44 137 45 141 47 145 49 149 50 153 51 333 64 366 65)
#(2 0 65)
#(2 306 5 65)
#(2 0 65)
#(3 293 23 337 33)
#(2 286 1 2 3 4 6 8 11 12 13 14 16 19 20 21 22 30 65)
#(3 173 6 341 32 0 65)
#(2 382 1 2 3 4 5 6 8 10 11 12 13 14 16 19 20 21 22 23 30 65)
#(2 278 1 2 3 4 6 8 11 12 13 14 16 19 20 21 22 23 30 65)
#(2 298 1 2 3 4 6 8 11 12 13 14 16 19 20 21 22 30 65)
#(3 185 22 345 67)
#(3 45 1 49 2 57 4 173 6 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 177 32 105 35 109 36 113 38 117 40 121 41 125 42 129 43 133 44 137 45 141 47 145 49 149 50 153 51 349 58 333 64 366 65)
#(3 45 1 49 2 53 3 57 4 173 6 61 8 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 341 32 105 35 109 36 113 38 117 40 121 41 125 42 129 43 133 44 137 45 141 47 145 49 149 50 153 51 157 56 353 60 165 64 366 65)
#(2 18 65)
#(3 42 5 357 9 42 15 361 37 42 65)
#(3 185 22 365 67)
#(3 369 3 373 5 377 8 381 10)
#(2 385 5)
#(3 389 3 97 22 393 35)
#(3 314 5 314 19 397 61)
#(3 322 2 322 4 322 11 322 12 322 13 322 14 322 17 322 19 322 20 322 21 322 22 322 23 322 24 322 25 322 27 322 30 322 31 401 62)
#(2 150 2 4 5 7 9 11 12 13 14 15 17 18 19 20 21 22 23 24 25 27 30 31 65)
#(2 154 2 4 5 7 9 11 12 13 14 15 17 18 19 20 21 22 23 24 25 27 30 31 65)
#(2 162 2 4 5 7 9 11 12 13 14 15 17 18 19 20 21 22 23 24 25 27 30 31 65)
#(2 166 2 4 5 7 9 11 12 13 14 15 17 18 19 20 21 22 23 24 25 27 30 31 65)
#(2 158 2 4 5 7 9 11 12 13 14 15 17 18 19 20 21 22 23 24 25 27 30 31 65)
#(2 170 2 4 5 7 9 11 12 13 14 15 17 18 19 20 21 22 23 24 25 27 30 31 65)
#(2 405 17)
#(2 409 15)
#(3 49 2 57 4 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 105 35 413 38 117 40 121 41 125 42 129 43 133 44 137 45 141 47 145 49 149 50 153 51)
#(3 417 1 49 2 57 4 46 5 65 11 69 12 73 13 77 14 46 15 81 16 85 19 89 20 93 21 97 22 101 30 105 35 421 38 117 40 121 41 125 42 129 43 133 44 137 45 141 47 145 49 149 50 153 51 46 65)
#(2 370 5 15 65)
#(3 289 22 293 23 297 25 425 33 429 48 433 52 437 53)
#(2 242 5 7 9 15 17 18 22 23 25 65)
#(3 49 2 57 4 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 441 35 117 40 445 43 133 44 137 45 449 50 453 51 457 54)
#(3 49 2 57 4 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 441 35 117 40 461 43 133 44 137 45 465 51 469 55)
#(3 218 5 218 9 218 15 218 17 218 18 473 23 218 65)
#(2 238 5 7 9 15 17 18 22 23 25 65)
#(2 230 5 7 9 15 17 18 23 25 65)
#(3 210 5 210 9 210 15 210 17 210 18 473 23 210 65)
#(2 222 5 7 9 15 17 18 23 25 65)
#(3 214 5 214 9 214 15 214 17 214 18 473 23 214 65)
#(2 234 5 7 9 15 17 18 22 23 25 65)
#(2 226 5 7 9 15 17 18 23 25 65)
#(2 310 5 65)
#(3 477 7 473 23)
#(2 290 1 2 3 4 6 8 11 12 13 14 16 19 20 21 22 30 65)
#(2 282 1 2 3 4 6 8 11 12 13 14 16 19 20 21 22 23 30 65)
#(3 45 1 49 2 57 4 173 6 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 341 32 105 35 109 36 113 38 117 40 121 41 125 42 129 43 133 44 137 45 141 47 145 49 149 50 153 51 481 64 366 65)
#(2 22 65)
#(2 46 5 15 65)
#(2 378 5 15 65)
#(2 62 3 5 8 10)
#(3 45 1 49 2 53 3 57 4 366 5 61 8 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 105 35 109 36 113 38 117 40 121 41 125 42 129 43 133 44 137 45 141 47 145 49 149 50 153 51 157 56 485 60 165 64)
#(2 78 5 7 9 15 17 18 22 23 25 65)
#(3 386 3 386 22 489 68)
#(3 185 22 493 67)
#(2 74 5 7 9 15 17 18 22 23 25 65)
#(2 274 1 2 4 5 6 11 12 13 14 16 19 20 21 22 30 65)
#(2 390 3 22)
#(3 497 5 501 19)
#(3 505 2 57 4 65 11 69 12 73 13 509 14 513 17 85 19 89 20 93 21 517 22 521 23 525 24 529 25 533 27 101 30 537 31 541 45 545 63)
#(2 98 5 7 9 15 17 18 22 23 25 65)
#(2 118 5 7 9 15 17 18 22 23 25 65)
#(2 86 5 9 15 17 65)
#(3 49 2 57 4 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 105 35 549 38 117 40 121 41 125 42 129 43 133 44 137 45 141 47 145 49 149 50 153 51)
#(2 38 5 9 15 65)
#(3 206 5 206 9 206 15 206 17 206 18 473 23 206 65)
#(2 94 5 9 15 17 18 65)
#(2 198 5 9 15 17 18 65)
#(2 202 5 9 15 17 18 65)
#(2 114 5 7 9 15 17 18 22 23 25 65)
#(3 258 5 258 7 258 9 258 15 258 17 258 18 289 22 258 23 297 25 305 52 309 53 258 65)
#(3 250 5 250 7 250 9 250 15 250 17 250 18 250 23 297 25 317 53 250 65)
#(3 254 5 254 7 254 9 254 15 254 17 254 18 289 22 254 23 297 25 325 52 329 53 254 65)
#(2 10 5 7 9 15 17 18 23 65)
#(3 266 5 266 7 266 9 266 15 266 17 266 18 289 22 266 23 266 25 305 52 266 65)
#(3 262 5 262 7 262 9 262 15 262 17 262 18 289 22 262 23 262 25 325 52 262 65)
#(2 246 5 7 9 15 17 18 23 25 65)
#(3 49 2 57 4 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 441 35 117 40 445 43 133 44 137 45 449 50 453 51 553 54)
#(2 6 1 2 3 4 6 8 11 12 13 14 16 19 20 21 22 30 65)
#(2 26 65)
#(2 557 5)
#(3 561 3 97 22 393 35)
#(2 66 3 5 8 10)
#(2 174 2 4 5 7 9 11 12 13 14 15 17 18 19 20 21 22 23 24 25 27 30 31 65)
#(2 318 5 19)
#(3 314 5 314 19 565 61)
#(3 322 2 322 4 322 11 322 12 322 13 322 14 322 17 322 19 322 20 322 21 322 22 322 23 322 24 322 25 322 27 322 30 322 31 569 62)
#(2 178 2 4 5 7 9 11 12 13 14 15 17 18 19 20 21 22 23 24 25 27 30 31 65)
#(2 334 2 4 11 12 13 14 17 19 20 21 22 23 24 25 27 30 31)
#(2 342 2 4 11 12 13 14 17 19 20 21 22 23 24 25 27 30 31)
#(2 346 2 4 11 12 13 14 17 19 20 21 22 23 24 25 27 30 31)
#(2 338 2 4 11 12 13 14 17 19 20 21 22 23 24 25 27 30 31)
#(2 350 2 4 11 12 13 14 17 19 20 21 22 23 24 25 27 30 31)
#(2 362 2 4 11 12 13 14 17 19 20 21 22 23 24 25 27 30 31)
#(2 330 2 4 11 12 13 14 17 19 20 21 22 23 24 25 27 30 31)
#(2 326 2 4 11 12 13 14 17 19 20 21 22 23 24 25 27 30 31)
#(3 42 5 357 9 42 15 573 37 42 65)
#(2 14 5 7 9 15 17 18 23 65)
#(2 70 5 7 9 15 17 18 22 23 25 65)
#(3 45 1 49 2 57 4 366 5 65 11 69 12 73 13 77 14 81 16 85 19 89 20 93 21 97 22 101 30 105 35 109 36 113 38 117 40 121 41 125 42 129 43 133 44 137 45 141 47 145 49 149 50 153 51 577 64)
#(3 581 5 501 19)
#(3 505 2 57 4 65 11 69 12 73 13 509 14 585 17 85 19 89 20 93 21 517 22 521 23 525 24 529 25 533 27 101 30 537 31 541 45 545 63)
#(2 374 5 15 65)
#(2 589 5)
#(2 358 2 4 11 12 13 14 17 19 20 21 22 23 24 25 27 30 31)
#(2 354 2 4 11 12 13 14 17 19 20 21 22 23 24 25 27 30 31)
#(2 82 5 7 9 15 17 18 22 23 25 65)
)! !

!CMParser class methodsFor: 'generated-starting states' stamp: 'cwp 5/26/2004 11:52'!
startingStateForSequence
	^2! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
array

	^ #()! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
messagePart: nodes

	^ {{nodes first}. {nodes second}}! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 14:13'!
litChar: nodes

	^ CMLiteral
		token: nodes first
		value: (nodes first value at: 2)! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 13:50'!
blockNoArgs: nodes

	^ (CMBlock
		body: nodes second)
			leftBracket: nodes first rightBracket: nodes third
		! !

!CMParser class methodsFor: 'generated-starting states' stamp: 'cwp 5/26/2004 11:52'!
startingStateForMethodPattern
	^3! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
byteStream

	^ ByteArray new writeStream! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 10:20'!
return: nodes
	| statement |
	statement _ Array new: nodes size - 1.
	statement at: 1 put: (CMReturn return: nodes first value: nodes second).
	nodes size = 3 ifTrue: [statement at: 2 put: nodes third].
	^ statement! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
contents2: nodes

	^ nodes second contents! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
add: nodes

	^ nodes first copyWith: nodes second! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/26/2004 12:17'!
methodTempsPrim: nodes

	^ CMMethod
		selectorParts: nodes first first
		arguments: nodes first last
		annotations: nodes third
		body: (self sequenceWithTemps: {nodes second. nodes fourth})! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 18:41'!
messageSend: nodes

	^ CMMessage
		receiver: nodes first
		selectorParts: nodes second first
		arguments: nodes second last! !

!CMParser class methodsFor: 'parsing' stamp: 'cwp 5/24/2004 13:46'!
parseExpression: aString
	^ self parse: aString startingAt: self startingStateForSequence! !

!CMParser class methodsFor: 'parsing' stamp: 'cwp 5/26/2004 11:53'!
parseAnnotations: aString
	^ self parse: aString startingAt: self startingStateForAnnotations! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
byteStreamPut: nodes

	^ nodes first
		nextPut: nodes second value asNumber;
		yourself! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 14:36'!
colonAdd: nodes
	nodes second colon: nodes first.
	^ OrderedCollection with: nodes second! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 19:57'!
litArray: nodes
	| token |
	token _ String streamContents: [:stream |
						stream 
							nextPutAll: nodes first value;
							nextPutAll: nodes second value.
						nodes third contents do: [:ea | stream nextPutAll: ea asString]
											separatedBy: [stream nextPut: $ ].
						stream nextPutAll: nodes fourth value].				
	^ CMLiteral
		token: (CMToken
				id: #()
				value: token
				whitespace: '')
		value: nodes third contents! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 13:22'!
array: nodes
	^ self 
		divideStatements: nodes second
		in: [:s :p | (CMArray statements: s periods: p)
						leftBrace: nodes first
						rightBrace: nodes third]! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 14:48'!
litSymbol: nodes

	^ CMLiteral
		token: nodes second
		value: nodes second value asSymbol! !

!CMParser class methodsFor: 'generated-starting states' stamp: 'cwp 5/26/2004 11:52'!
startingStateForAnnotations
	^4! !

!CMParser methodsFor: 'generated-reduction actions' stamp: 'cwp 5/26/2004 11:52'!
reduceActionForOptionalXXXXX2: nodes 
	^nodes at: 1! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 13:43'!
litNumber: nodes

	| str num |
	str _ nodes first value readStream.
	num _ Number readFrom: str.
	str atEnd ifFalse: [
		currentToken _ nil.
		scanner position: scanner position - (str originalContents size - str position) + 1.
		self reportErrorMessage: 'Digit out of range'].
	^ CMLiteral token: nodes first value: num! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 13:57'!
blockArgs: nodes

	^ (CMBlock
		arguments: nodes second
		body: (CMSequence statements: #() periods: #()))
					leftBracket: nodes first rightBracket: nodes third! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 11:57'!
sequenceWithTemps: nodes
	^ self 
		divideStatements: nodes second
		in: [:s :p | (CMSequence temporaries: nodes first second statements: s periods: p)
						leftBar: nodes first first
						rightBar: nodes first third]! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 14:14'!
litNil: nodes

	^ CMLiteral
		token: nodes first
		value: nil! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
stream

	^ Array new writeStream! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 14:14'!
litString: nodes

	| s |
	s _ nodes first value.
	^ CMLiteral
		token: nodes first
		value: ((s copyFrom: 2 to: s size - 1)
				copyReplaceAll: '''''' with: '''')! !

!CMParser methodsFor: 'private' stamp: 'cwp 5/25/2004 11:45'!
divideStatements: aCollection in: aBlock
	| statements periods |
	statements _ OrderedCollection new.
	periods _ OrderedCollection new.
	aCollection pairsDo: [:s :p | statements add: s. p ifNotNil: [periods add: p]].
	^ aBlock value: statements value: periods
	! !

!CMParser methodsFor: 'generated-reduction actions' stamp: 'cwp 5/26/2004 11:52'!
reduceActionForOptionalXXXXX1: nodes 
	^nil! !

!CMParser class methodsFor: 'generated-comments' stamp: 'cwp 5/26/2004 11:52'!
itemSetsComment

	"
1	[KeywordMethodPattern : .  KeywordMethodPattern <keyword> Argument;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> <keyword> ""^""]
	[MethodPattern : .  <name>;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]
	[MethodPattern : .  KeywordMethodPattern;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]
	[B e g i n : .  Method;E O F]
	[KeywordMethodPattern : .  <keyword> Argument;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> <keyword> ""^""]
	[MethodPattern : .  <binarySymbol> Argument;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]
	[Method : .  MethodPattern Annotations Sequence;E O F]
	[Method : .  MethodPattern Temporaries Annotations Statements;E O F]
	[Method : .  MethodPattern Sequence;E O F]

2	[Cascade : .  Cascade "";"" Message;E O F "";"" "".""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" BlockArgs ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""false"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Cascade : .  MessageSend;E O F "";"" "".""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Primary : .  Literal;<name> E O F ""."" <keyword> <binarySymbol>]
	[UnaryMessageSend : .  Primary UnaryMessage;"";"" ""."" <name> E O F <binarySymbol> <keyword>]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;""."" E O F "";"" <keyword> <binarySymbol>]
	[Literal : .  <negativeNumber>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <string>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  <number>;<name> E O F ""."" <keyword> <binarySymbol>]
	[BinaryMessageSend : .  Primary BinaryMessage;""."" E O F "";"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <binarySymbol>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Statements : .  StatementList Optional: ""."";E O F]
	[KeywordMessageSend : .  Primary KeywordMessage;E O F "";"" "".""]
	[Literal : .  ""true"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Sequence : .  Statements;E O F]
	[StatementList : .  StatementList ""."" Expression;E O F "".""]
	[Expression : .  Primary;E O F "".""]
	[Statements : .  StatementList ""."" ""^"" Expression Optional: ""."";E O F]
	[Statements : . ;E O F]
	[KeywordMessageSend : .  BinaryMessageSend KeywordMessage;E O F "";"" "".""]
	[Expression : .  Assignment;E O F "".""]
	[Literal : .  <character>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Primary : .  Block;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""nil"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <alternateKeyword>;<name> E O F ""."" <keyword> <binarySymbol>]
	[StatementList : .  Expression;E O F "".""]
	[Statements : .  ""^"" Expression Optional: ""."";E O F]
	[Literal : .  <string>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Expression : .  Cascade;E O F "".""]
	[Array : .  ""{"" Statements ""}"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Variable : .  <name>;""."" <name> <assignment> E O F <binarySymbol> <keyword>]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;""."" E O F "";"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <multikeyword>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <name>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Primary : .  Variable;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <keyword>;<name> E O F ""."" <keyword> <binarySymbol>]
	[MessageSend : .  UnaryMessageSend;E O F "";"" "".""]
	[B e g i nSequence : .  Sequence;E O F]
	[Temporaries : .  ""||"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""false"" E O F <negativeNumber> ""^""]
	[MessageSend : .  BinaryMessageSend;E O F "";"" "".""]
	[Assignment : .  Variable <assignment> Expression;E O F "".""]
	[KeywordMessageSend : .  UnaryMessageSend KeywordMessage;E O F "";"" "".""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;"";"" ""."" <name> E O F <binarySymbol> <keyword>]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[MessageSend : .  KeywordMessageSend;E O F "";"" "".""]
	[Temporaries : .  ""|"" TemporaryVariables ""|"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""false"" E O F <negativeNumber> ""^""]
	[Primary : .  Array;<name> E O F ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" Sequence ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Sequence : .  Temporaries Statements;E O F]
	[Primary : .  ""("" Expression "")"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" ""["" ByteArray ""]"";<name> E O F ""."" <keyword> <binarySymbol>]

3	[B e g i nMethodPattern : .  MethodPattern;E O F]
	[KeywordMethodPattern : .  KeywordMethodPattern <keyword> Argument;E O F <keyword>]
	[MethodPattern : .  <name>;E O F]
	[KeywordMethodPattern : .  <keyword> Argument;E O F <keyword>]
	[MethodPattern : .  KeywordMethodPattern;E O F]
	[MethodPattern : .  <binarySymbol> Argument;E O F]

4	[B e g i nAnnotations : .  Annotations;E O F]
	[Annotations : .  Annotations Annotation;E O F ""<""]
	[Annotations : .  Annotation;E O F ""<""]
	[Annotation : .  ""<"" KeywordMessage "">"";E O F ""<""]

5	[MethodPattern : <name> . ;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]

6	[Argument : .  <name>;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> <keyword> ""^""]
	[KeywordMethodPattern : <keyword> .  Argument;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> <keyword> ""^""]

7	[MethodPattern : <binarySymbol> .  Argument;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]
	[Argument : .  <name>;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]

8	[B e g i n : Method . ;E O F]

9	[KeywordMethodPattern : KeywordMethodPattern .  <keyword> Argument;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> <keyword> ""^""]
	[MethodPattern : KeywordMethodPattern . ;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]

10	[Cascade : .  Cascade "";"" Message;E O F "";"" "".""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" BlockArgs ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""false"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Cascade : .  MessageSend;E O F "";"" "".""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Primary : .  Literal;<name> E O F ""."" <keyword> <binarySymbol>]
	[UnaryMessageSend : .  Primary UnaryMessage;"";"" ""."" <name> E O F <binarySymbol> <keyword>]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;""."" E O F "";"" <keyword> <binarySymbol>]
	[Literal : .  <negativeNumber>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <string>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  <number>;<name> E O F ""."" <keyword> <binarySymbol>]
	[BinaryMessageSend : .  Primary BinaryMessage;""."" E O F "";"" <keyword> <binarySymbol>]
	[Annotations : .  Annotations Annotation;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]
	[Literal : .  ""#"" <binarySymbol>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Statements : .  StatementList Optional: ""."";E O F]
	[KeywordMessageSend : .  Primary KeywordMessage;E O F "";"" "".""]
	[Literal : .  ""true"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Sequence : .  Statements;E O F]
	[StatementList : .  StatementList ""."" Expression;E O F "".""]
	[Expression : .  Primary;E O F "".""]
	[Statements : .  StatementList ""."" ""^"" Expression Optional: ""."";E O F]
	[Statements : . ;E O F]
	[KeywordMessageSend : .  BinaryMessageSend KeywordMessage;E O F "";"" "".""]
	[Expression : .  Assignment;E O F "".""]
	[Primary : .  Block;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  <character>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Method : MethodPattern .  Annotations Sequence;E O F]
	[Literal : .  ""nil"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <alternateKeyword>;<name> E O F ""."" <keyword> <binarySymbol>]
	[StatementList : .  Expression;E O F "".""]
	[Statements : .  ""^"" Expression Optional: ""."";E O F]
	[Literal : .  <string>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Expression : .  Cascade;E O F "".""]
	[Array : .  ""{"" Statements ""}"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Variable : .  <name>;""."" <name> <assignment> E O F <binarySymbol> <keyword>]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;""."" E O F "";"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <multikeyword>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Method : MethodPattern .  Sequence;E O F]
	[Literal : .  ""#"" <name>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <keyword>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Primary : .  Variable;<name> E O F ""."" <keyword> <binarySymbol>]
	[MessageSend : .  UnaryMessageSend;E O F "";"" "".""]
	[Temporaries : .  ""||"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> ""<"" <string> ""#"" ""false"" E O F <negativeNumber> ""^""]
	[MessageSend : .  BinaryMessageSend;E O F "";"" "".""]
	[Assignment : .  Variable <assignment> Expression;E O F "".""]
	[Annotations : .  Annotation;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]
	[KeywordMessageSend : .  UnaryMessageSend KeywordMessage;E O F "";"" "".""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;"";"" ""."" <name> E O F <binarySymbol> <keyword>]
	[Method : MethodPattern .  Temporaries Annotations Statements;E O F]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[MessageSend : .  KeywordMessageSend;E O F "";"" "".""]
	[Temporaries : .  ""|"" TemporaryVariables ""|"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> ""<"" <string> ""#"" ""false"" E O F <negativeNumber> ""^""]
	[Primary : .  Array;<name> E O F ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" Sequence ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Sequence : .  Temporaries Statements;E O F]
	[Primary : .  ""("" Expression "")"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Annotation : .  ""<"" KeywordMessage "">"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]
	[Literal : .  ""#"" ""["" ByteArray ""]"";<name> E O F ""."" <keyword> <binarySymbol>]

11	[Cascade : .  Cascade "";"" Message;""}"" E O F ""]"" "";"" "".""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Block : .  ""["" BlockArgs ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  ""false"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Cascade : .  MessageSend;""}"" E O F ""]"" "";"" "".""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Primary : .  Literal;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[UnaryMessageSend : .  Primary UnaryMessage;"";"" ""."" <name> E O F <binarySymbol> ""]"" <keyword> ""}""]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;"";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]
	[Literal : .  <negativeNumber>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  ""#"" <string>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  <number>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[BinaryMessageSend : .  Primary BinaryMessage;"";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" <binarySymbol>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Statements : ""^"" .  Expression Optional: ""."";E O F ""]"" ""}""]
	[KeywordMessageSend : .  Primary KeywordMessage;""}"" E O F ""]"" "";"" "".""]
	[Literal : .  ""true"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Expression : .  Primary;""}"" E O F ""]"" "".""]
	[KeywordMessageSend : .  BinaryMessageSend KeywordMessage;""}"" E O F ""]"" "";"" "".""]
	[Literal : .  ""#"" <alternateKeyword>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  <character>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Expression : .  Assignment;""}"" E O F ""]"" "".""]
	[Literal : .  ""nil"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Primary : .  Block;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  <string>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Expression : .  Cascade;""}"" E O F ""]"" "".""]
	[Array : .  ""{"" Statements ""}"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Variable : .  <name>;""}"" ""."" <name> <assignment> E O F <binarySymbol> <keyword> ""]""]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;"";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" <multikeyword>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  ""#"" <name>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Primary : .  Variable;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  ""#"" <keyword>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[MessageSend : .  UnaryMessageSend;""}"" E O F ""]"" "";"" "".""]
	[MessageSend : .  BinaryMessageSend;""}"" E O F ""]"" "";"" "".""]
	[Assignment : .  Variable <assignment> Expression;""}"" E O F ""]"" "".""]
	[KeywordMessageSend : .  UnaryMessageSend KeywordMessage;""}"" E O F ""]"" "";"" "".""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;"";"" ""."" <name> E O F <binarySymbol> ""]"" <keyword> ""}""]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[MessageSend : .  KeywordMessageSend;""}"" E O F ""]"" "";"" "".""]
	[Primary : .  Array;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Block : .  ""["" Sequence ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Primary : .  ""("" Expression "")"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  ""#"" ""["" ByteArray ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]

12	[Cascade : .  Cascade "";"" Message;""]"" "";"" "".""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" BlockArgs ""]"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""false"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Cascade : .  MessageSend;""]"" "";"" "".""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Primary : .  Literal;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[UnaryMessageSend : .  Primary UnaryMessage;"";"" ""."" <name> ""]"" <binarySymbol> <keyword>]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;""."" ""]"" "";"" <keyword> <binarySymbol>]
	[Literal : .  <negativeNumber>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <string>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  <number>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[BinaryMessageSend : .  Primary BinaryMessage;""."" ""]"" "";"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <binarySymbol>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Statements : .  StatementList Optional: ""."";""]""]
	[KeywordMessageSend : .  Primary KeywordMessage;""]"" "";"" "".""]
	[Literal : .  ""true"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Sequence : .  Statements;""]""]
	[StatementList : .  StatementList ""."" Expression;""]"" "".""]
	[Expression : .  Primary;""]"" "".""]
	[Statements : .  StatementList ""."" ""^"" Expression Optional: ""."";""]""]
	[Statements : . ;""]""]
	[KeywordMessageSend : .  BinaryMessageSend KeywordMessage;""]"" "";"" "".""]
	[Expression : .  Assignment;""]"" "".""]
	[Literal : .  <character>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Primary : .  Block;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""nil"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <alternateKeyword>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Block : ""["" .  BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[StatementList : .  Expression;""]"" "".""]
	[Statements : .  ""^"" Expression Optional: ""."";""]""]
	[Literal : .  <string>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Block : ""["" .  Sequence ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Expression : .  Cascade;""]"" "".""]
	[Variable : .  <name>;""."" <name> <assignment> ""]"" <binarySymbol> <keyword>]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;""."" ""]"" "";"" <keyword> <binarySymbol>]
	[Array : .  ""{"" Statements ""}"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[BlockArgs : .  "":"" Argument;"":"" ""|"" ""]"" ""||""]
	[BlockArgs : .  BlockArgs "":"" Argument;"":"" ""|"" ""]"" ""||""]
	[Literal : .  ""#"" <name>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <keyword>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Block : ""["" .  BlockArgs ""|"" Sequence ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Block : ""["" .  BlockArgs ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" <multikeyword>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Primary : .  Variable;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[MessageSend : .  UnaryMessageSend;""]"" "";"" "".""]
	[Temporaries : .  ""||"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""false"" ""]"" <negativeNumber> ""^""]
	[MessageSend : .  BinaryMessageSend;""]"" "";"" "".""]
	[Assignment : .  Variable <assignment> Expression;""]"" "".""]
	[KeywordMessageSend : .  UnaryMessageSend KeywordMessage;""]"" "";"" "".""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;"";"" ""."" <name> ""]"" <binarySymbol> <keyword>]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[MessageSend : .  KeywordMessageSend;""]"" "";"" "".""]
	[Temporaries : .  ""|"" TemporaryVariables ""|"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""false"" ""]"" <negativeNumber> ""^""]
	[Primary : .  Array;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" Sequence ""]"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Sequence : .  Temporaries Statements;""]""]
	[Primary : .  ""("" Expression "")"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" ""["" ByteArray ""]"";<name> ""]"" ""."" <keyword> <binarySymbol>]

13	[Temporaries : ""|"" .  TemporaryVariables ""|"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""false"" E O F <negativeNumber> ""]"" ""^""]
	[TemporaryVariables : . ;<name> ""|""]
	[TemporaryVariables : .  TemporaryVariables Variable;<name> ""|""]

14	[Literal : ""#"" .  <binarySymbol>;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]
	[Literal : ""#"" .  ""("" LiteralArray "")"";<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]
	[Literal : ""#"" .  <alternateKeyword>;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]
	[Literal : ""#"" .  ""["" ByteArray ""]"";<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]
	[Literal : ""#"" .  <multikeyword>;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]
	[Literal : ""#"" .  <name>;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]
	[Literal : ""#"" .  <string>;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]
	[Literal : ""#"" .  <keyword>;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

15	[Temporaries : ""||"" . ;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""false"" E O F <negativeNumber> ""]"" ""^""]

16	[Literal : ""false"" . ;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

17	[Literal : ""nil"" . ;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

18	[Literal : ""true"" . ;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

19	[Cascade : .  Cascade "";"" Message;"";"" "")""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";<name> "")"" <keyword> <binarySymbol>]
	[Block : .  ""["" BlockArgs ""]"";<name> "")"" <keyword> <binarySymbol>]
	[Literal : .  ""false"";<name> "")"" <keyword> <binarySymbol>]
	[Cascade : .  MessageSend;"";"" "")""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";<name> "")"" <keyword> <binarySymbol>]
	[Primary : .  Literal;<name> "")"" <keyword> <binarySymbol>]
	[UnaryMessageSend : .  Primary UnaryMessage;<name> "")"" "";"" <keyword> <binarySymbol>]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;"")"" "";"" <keyword> <binarySymbol>]
	[Literal : .  <negativeNumber>;<name> "")"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <string>;<name> "")"" <keyword> <binarySymbol>]
	[Literal : .  <number>;<name> "")"" <keyword> <binarySymbol>]
	[BinaryMessageSend : .  Primary BinaryMessage;"")"" "";"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <binarySymbol>;<name> "")"" <keyword> <binarySymbol>]
	[KeywordMessageSend : .  Primary KeywordMessage;"";"" "")""]
	[Literal : .  ""true"";<name> "")"" <keyword> <binarySymbol>]
	[Expression : .  Primary;"")""]
	[KeywordMessageSend : .  BinaryMessageSend KeywordMessage;"";"" "")""]
	[Literal : .  ""#"" <alternateKeyword>;<name> "")"" <keyword> <binarySymbol>]
	[Literal : .  <character>;<name> "")"" <keyword> <binarySymbol>]
	[Expression : .  Assignment;"")""]
	[Literal : .  ""nil"";<name> "")"" <keyword> <binarySymbol>]
	[Primary : .  Block;<name> "")"" <keyword> <binarySymbol>]
	[Literal : .  <string>;<name> "")"" <keyword> <binarySymbol>]
	[Expression : .  Cascade;"")""]
	[Array : .  ""{"" Statements ""}"";<name> "")"" <keyword> <binarySymbol>]
	[Variable : .  <name>;<name> <assignment> "")"" <keyword> <binarySymbol>]
	[Primary : ""("" .  Expression "")"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;"")"" "";"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <name>;<name> "")"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <multikeyword>;<name> "")"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <keyword>;<name> "")"" <keyword> <binarySymbol>]
	[Primary : .  Variable;<name> "")"" <keyword> <binarySymbol>]
	[MessageSend : .  UnaryMessageSend;"";"" "")""]
	[MessageSend : .  BinaryMessageSend;"";"" "")""]
	[Assignment : .  Variable <assignment> Expression;"")""]
	[KeywordMessageSend : .  UnaryMessageSend KeywordMessage;"";"" "")""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;<name> "")"" "";"" <keyword> <binarySymbol>]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";<name> "")"" <keyword> <binarySymbol>]
	[MessageSend : .  KeywordMessageSend;"";"" "")""]
	[Block : .  ""["" Sequence ""]"";<name> "")"" <keyword> <binarySymbol>]
	[Primary : .  Array;<name> "")"" <keyword> <binarySymbol>]
	[Primary : .  ""("" Expression "")"";<name> "")"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" ""["" ByteArray ""]"";<name> "")"" <keyword> <binarySymbol>]

20	[Cascade : .  Cascade "";"" Message;""."" "";"" ""}""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Block : .  ""["" BlockArgs ""]"";<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Literal : .  ""false"";<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Cascade : .  MessageSend;""."" "";"" ""}""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Primary : .  Literal;<name> ""."" ""}"" <keyword> <binarySymbol>]
	[UnaryMessageSend : .  Primary UnaryMessage;"";"" ""."" <name> <binarySymbol> <keyword> ""}""]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;""."" ""}"" "";"" <keyword> <binarySymbol>]
	[Literal : .  <negativeNumber>;<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <string>;<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Literal : .  <number>;<name> ""."" ""}"" <keyword> <binarySymbol>]
	[BinaryMessageSend : .  Primary BinaryMessage;""."" ""}"" "";"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <binarySymbol>;<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Statements : .  StatementList Optional: ""."";""}""]
	[Array : ""{"" .  Statements ""}"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[KeywordMessageSend : .  Primary KeywordMessage;""."" "";"" ""}""]
	[Literal : .  ""true"";<name> ""."" ""}"" <keyword> <binarySymbol>]
	[StatementList : .  StatementList ""."" Expression;""."" ""}""]
	[Expression : .  Primary;""}"" "".""]
	[Statements : .  StatementList ""."" ""^"" Expression Optional: ""."";""}""]
	[Statements : . ;""}""]
	[KeywordMessageSend : .  BinaryMessageSend KeywordMessage;""."" "";"" ""}""]
	[Literal : .  ""#"" <alternateKeyword>;<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Literal : .  <character>;<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Expression : .  Assignment;""}"" "".""]
	[Literal : .  ""nil"";<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Primary : .  Block;<name> ""."" ""}"" <keyword> <binarySymbol>]
	[StatementList : .  Expression;""."" ""}""]
	[Statements : .  ""^"" Expression Optional: ""."";""}""]
	[Literal : .  <string>;<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Expression : .  Cascade;""}"" "".""]
	[Array : .  ""{"" Statements ""}"";<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Variable : .  <name>;""."" <name> <assignment> <binarySymbol> <keyword> ""}""]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;""."" ""}"" "";"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <multikeyword>;<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <name>;<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Primary : .  Variable;<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <keyword>;<name> ""."" ""}"" <keyword> <binarySymbol>]
	[MessageSend : .  UnaryMessageSend;""}"" "";"" "".""]
	[MessageSend : .  BinaryMessageSend;""}"" "";"" "".""]
	[Assignment : .  Variable <assignment> Expression;""."" ""}""]
	[KeywordMessageSend : .  UnaryMessageSend KeywordMessage;""."" "";"" ""}""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;"";"" ""."" <name> <binarySymbol> <keyword> ""}""]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";<name> ""."" ""}"" <keyword> <binarySymbol>]
	[MessageSend : .  KeywordMessageSend;""}"" "";"" "".""]
	[Primary : .  Array;<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Block : .  ""["" Sequence ""]"";<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Primary : .  ""("" Expression "")"";<name> ""."" ""}"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" ""["" ByteArray ""]"";<name> ""."" ""}"" <keyword> <binarySymbol>]

21	[Literal : <number> . ;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

22	[Literal : <negativeNumber> . ;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

23	[Literal : <string> . ;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

24	[Variable : <name> . ;"">"" "";"" <binarySymbol> <name> <assignment> "")"" ""|"" ""."" E O F ""]"" <keyword> ""}""]

25	[Literal : <character> . ;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

26	[Assignment : Variable .  <assignment> Expression;"")"" E O F ""]"" ""}"" "".""]
	[Primary : Variable . ;""}"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> "")""]

27	[Optional: ""."" : . ;E O F ""]"" ""}""]
	[Optional: ""."" : .  ""."";E O F ""]"" ""}""]
	[StatementList : StatementList .  ""."" Expression;""}"" E O F ""]"" "".""]
	[Statements : StatementList .  Optional: ""."";E O F ""]"" ""}""]
	[Statements : StatementList .  ""."" ""^"" Expression Optional: ""."";E O F ""]"" ""}""]

28	[StatementList : Expression . ;""}"" E O F ""]"" "".""]

29	[Primary : Block . ;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]

30	[Expression : Assignment . ;"")"" E O F ""]"" ""}"" "".""]

31	[Expression : Cascade . ;"")"" E O F ""]"" ""}"" "".""]
	[Cascade : Cascade .  "";"" Message;""}"" "";"" ""."" E O F ""]"" "")""]

32	[UnaryMessage : .  <name>;""}"" "";"" ""."" <name> E O F <binarySymbol> ""]"" <keyword> "")""]
	[KeywordMessage : .  <keyword> KeywordArgument;""}"" "";"" ""."" E O F ""]"" <keyword> "")""]
	[KeywordMessage : .  KeywordMessage <keyword> KeywordArgument;""}"" "";"" ""."" E O F ""]"" <keyword> "")""]
	[Expression : Primary . ;"")"" E O F ""]"" ""}"" "".""]
	[UnaryMessageSend : Primary .  UnaryMessage;""}"" "";"" <binarySymbol> <name> E O F ""."" ""]"" <keyword> "")""]
	[KeywordMessageSend : Primary .  KeywordMessage;""}"" "";"" ""."" E O F ""]"" "")""]
	[BinaryMessage : .  <binarySymbol> BinaryArgument;""}"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "")""]
	[BinaryMessageSend : Primary .  BinaryMessage;""}"" "";"" <binarySymbol> ""."" E O F ""]"" <keyword> "")""]

33	[Primary : Array . ;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]

34	[Primary : Literal . ;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]

35	[Cascade : MessageSend . ;""}"" "";"" ""."" E O F ""]"" "")""]

36	[MessageSend : KeywordMessageSend . ;""}"" "";"" ""."" E O F ""]"" "")""]

37	[KeywordMessage : .  <keyword> KeywordArgument;""}"" "";"" ""."" E O F ""]"" <keyword> "")""]
	[KeywordMessage : .  KeywordMessage <keyword> KeywordArgument;""}"" "";"" ""."" E O F ""]"" <keyword> "")""]
	[MessageSend : BinaryMessageSend . ;""}"" "";"" ""."" E O F ""]"" "")""]
	[BinaryMessageSend : BinaryMessageSend .  BinaryMessage;""}"" "";"" <binarySymbol> ""."" E O F ""]"" <keyword> "")""]
	[BinaryMessage : .  <binarySymbol> BinaryArgument;""}"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "")""]
	[KeywordMessageSend : BinaryMessageSend .  KeywordMessage;""}"" "";"" ""."" E O F ""]"" "")""]

38	[UnaryMessage : .  <name>;""}"" "";"" ""."" <name> E O F <binarySymbol> ""]"" <keyword> "")""]
	[KeywordMessageSend : UnaryMessageSend .  KeywordMessage;""}"" "";"" ""."" E O F ""]"" "")""]
	[KeywordMessage : .  KeywordMessage <keyword> KeywordArgument;""}"" "";"" ""."" E O F ""]"" <keyword> "")""]
	[KeywordMessage : .  <keyword> KeywordArgument;""}"" "";"" ""."" E O F ""]"" <keyword> "")""]
	[UnaryMessageSend : UnaryMessageSend .  UnaryMessage;""}"" "";"" <binarySymbol> <name> E O F ""."" ""]"" <keyword> "")""]
	[BinaryMessageSend : UnaryMessageSend .  BinaryMessage;""}"" "";"" <binarySymbol> ""."" E O F ""]"" <keyword> "")""]
	[MessageSend : UnaryMessageSend . ;""}"" "";"" ""."" E O F ""]"" "")""]
	[BinaryMessage : .  <binarySymbol> BinaryArgument;""}"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "")""]

39	[Cascade : .  Cascade "";"" Message;E O F ""]"" "";"" "".""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Block : .  ""["" BlockArgs ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Literal : .  ""false"";""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Cascade : .  MessageSend;E O F ""]"" "";"" "".""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Primary : .  Literal;""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[UnaryMessageSend : .  Primary UnaryMessage;"";"" ""."" <name> E O F <binarySymbol> ""]"" <keyword>]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;"";"" ""."" <binarySymbol> E O F ""]"" <keyword>]
	[Literal : .  <negativeNumber>;""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Literal : .  ""#"" <string>;""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Literal : .  <number>;""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[BinaryMessageSend : .  Primary BinaryMessage;"";"" ""."" <binarySymbol> E O F ""]"" <keyword>]
	[Literal : .  ""#"" <binarySymbol>;""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Statements : .  StatementList Optional: ""."";E O F ""]""]
	[KeywordMessageSend : .  Primary KeywordMessage;E O F ""]"" "";"" "".""]
	[Literal : .  ""true"";""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[StatementList : .  StatementList ""."" Expression;E O F ""]"" "".""]
	[Expression : .  Primary;E O F ""]"" "".""]
	[Statements : .  StatementList ""."" ""^"" Expression Optional: ""."";E O F ""]""]
	[Statements : . ;E O F ""]""]
	[KeywordMessageSend : .  BinaryMessageSend KeywordMessage;E O F ""]"" "";"" "".""]
	[Literal : .  ""#"" <alternateKeyword>;""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Literal : .  <character>;""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Expression : .  Assignment;E O F ""]"" "".""]
	[Literal : .  ""nil"";""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Primary : .  Block;""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[StatementList : .  Expression;E O F ""]"" "".""]
	[Statements : .  ""^"" Expression Optional: ""."";E O F ""]""]
	[Literal : .  <string>;""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Expression : .  Cascade;E O F ""]"" "".""]
	[Array : .  ""{"" Statements ""}"";""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Sequence : Temporaries .  Statements;E O F ""]""]
	[Variable : .  <name>;""."" <name> <assignment> E O F <binarySymbol> <keyword> ""]""]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;"";"" ""."" <binarySymbol> E O F ""]"" <keyword>]
	[Literal : .  ""#"" <name>;""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Literal : .  ""#"" <multikeyword>;""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Literal : .  ""#"" <keyword>;""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Primary : .  Variable;""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[MessageSend : .  UnaryMessageSend;E O F ""]"" "";"" "".""]
	[MessageSend : .  BinaryMessageSend;E O F ""]"" "";"" "".""]
	[Assignment : .  Variable <assignment> Expression;E O F ""]"" "".""]
	[KeywordMessageSend : .  UnaryMessageSend KeywordMessage;E O F ""]"" "";"" "".""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;"";"" ""."" <name> E O F <binarySymbol> ""]"" <keyword>]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[MessageSend : .  KeywordMessageSend;E O F ""]"" "";"" "".""]
	[Primary : .  Array;""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Block : .  ""["" Sequence ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Primary : .  ""("" Expression "")"";""."" <name> E O F ""]"" <binarySymbol> <keyword>]
	[Literal : .  ""#"" ""["" ByteArray ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword>]

40	[B e g i nSequence : Sequence . ;E O F]

41	[Sequence : Statements . ;E O F ""]""]

42	[B e g i nMethodPattern : MethodPattern . ;E O F]

43	[KeywordMessage : .  <keyword> KeywordArgument;<keyword> "">""]
	[Annotation : ""<"" .  KeywordMessage "">"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> ""<"" <string> ""#"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]
	[KeywordMessage : .  KeywordMessage <keyword> KeywordArgument;<keyword> "">""]

44	[Annotations : Annotation . ;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> ""<"" <string> ""#"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]

45	[Annotations : Annotations .  Annotation;E O F ""<""]
	[Annotation : .  ""<"" KeywordMessage "">"";E O F ""<""]
	[B e g i nAnnotations : Annotations . ;E O F]

46	[Argument : <name> . ;""["" ""("" <character> ""true"" "":"" ""{"" <string> ""#"" ""false"" ""|"" <negativeNumber> ""]"" <keyword> ""^"" ""nil"" <number> <name> ""<"" ""||"" E O F]

47	[KeywordMethodPattern : <keyword> Argument . ;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> <keyword> ""^""]

48	[MethodPattern : <binarySymbol> Argument . ;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]

49	[Argument : .  <name>;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> <keyword> ""^""]
	[KeywordMethodPattern : KeywordMethodPattern <keyword> .  Argument;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> <keyword> ""^""]

50	[Cascade : .  Cascade "";"" Message;E O F "";"" "".""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" BlockArgs ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""false"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Cascade : .  MessageSend;E O F "";"" "".""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Primary : .  Literal;<name> E O F ""."" <keyword> <binarySymbol>]
	[UnaryMessageSend : .  Primary UnaryMessage;"";"" ""."" <name> E O F <binarySymbol> <keyword>]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;""."" E O F "";"" <keyword> <binarySymbol>]
	[Literal : .  <negativeNumber>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <string>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  <number>;<name> E O F ""."" <keyword> <binarySymbol>]
	[BinaryMessageSend : .  Primary BinaryMessage;""."" E O F "";"" <keyword> <binarySymbol>]
	[Annotations : .  Annotations Annotation;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""false"" E O F <negativeNumber> ""^""]
	[Literal : .  ""#"" <binarySymbol>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Statements : .  StatementList Optional: ""."";E O F]
	[KeywordMessageSend : .  Primary KeywordMessage;E O F "";"" "".""]
	[Literal : .  ""true"";<name> E O F ""."" <keyword> <binarySymbol>]
	[StatementList : .  StatementList ""."" Expression;E O F "".""]
	[Expression : .  Primary;E O F "".""]
	[Statements : .  StatementList ""."" ""^"" Expression Optional: ""."";E O F]
	[Statements : . ;E O F]
	[KeywordMessageSend : .  BinaryMessageSend KeywordMessage;E O F "";"" "".""]
	[Expression : .  Assignment;E O F "".""]
	[Primary : .  Block;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  <character>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""nil"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <alternateKeyword>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Method : MethodPattern Temporaries .  Annotations Statements;E O F]
	[StatementList : .  Expression;E O F "".""]
	[Statements : .  ""^"" Expression Optional: ""."";E O F]
	[Literal : .  <string>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Expression : .  Cascade;E O F "".""]
	[Array : .  ""{"" Statements ""}"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Sequence : Temporaries .  Statements;E O F]
	[Variable : .  <name>;""."" <name> <assignment> E O F <binarySymbol> <keyword>]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;""."" E O F "";"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <name>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <multikeyword>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <keyword>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Primary : .  Variable;<name> E O F ""."" <keyword> <binarySymbol>]
	[MessageSend : .  UnaryMessageSend;E O F "";"" "".""]
	[MessageSend : .  BinaryMessageSend;E O F "";"" "".""]
	[Assignment : .  Variable <assignment> Expression;E O F "".""]
	[Annotations : .  Annotation;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""false"" E O F <negativeNumber> ""^""]
	[KeywordMessageSend : .  UnaryMessageSend KeywordMessage;E O F "";"" "".""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;"";"" ""."" <name> E O F <binarySymbol> <keyword>]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[MessageSend : .  KeywordMessageSend;E O F "";"" "".""]
	[Primary : .  Array;<name> E O F ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" Sequence ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Primary : .  ""("" Expression "")"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Annotation : .  ""<"" KeywordMessage "">"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""false"" E O F <negativeNumber> ""^""]
	[Literal : .  ""#"" ""["" ByteArray ""]"";<name> E O F ""."" <keyword> <binarySymbol>]

51	[Cascade : .  Cascade "";"" Message;E O F "";"" "".""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" BlockArgs ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""false"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Cascade : .  MessageSend;E O F "";"" "".""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Primary : .  Literal;<name> E O F ""."" <keyword> <binarySymbol>]
	[UnaryMessageSend : .  Primary UnaryMessage;"";"" ""."" <name> E O F <binarySymbol> <keyword>]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;""."" E O F "";"" <keyword> <binarySymbol>]
	[Literal : .  <negativeNumber>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Method : MethodPattern Annotations .  Sequence;E O F]
	[Literal : .  ""#"" <string>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  <number>;<name> E O F ""."" <keyword> <binarySymbol>]
	[BinaryMessageSend : .  Primary BinaryMessage;""."" E O F "";"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <binarySymbol>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Statements : .  StatementList Optional: ""."";E O F]
	[KeywordMessageSend : .  Primary KeywordMessage;E O F "";"" "".""]
	[Literal : .  ""true"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Sequence : .  Statements;E O F]
	[StatementList : .  StatementList ""."" Expression;E O F "".""]
	[Expression : .  Primary;E O F "".""]
	[Statements : .  StatementList ""."" ""^"" Expression Optional: ""."";E O F]
	[Statements : . ;E O F]
	[KeywordMessageSend : .  BinaryMessageSend KeywordMessage;E O F "";"" "".""]
	[Expression : .  Assignment;E O F "".""]
	[Primary : .  Block;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  <character>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""nil"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <alternateKeyword>;<name> E O F ""."" <keyword> <binarySymbol>]
	[StatementList : .  Expression;E O F "".""]
	[Statements : .  ""^"" Expression Optional: ""."";E O F]
	[Literal : .  <string>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Expression : .  Cascade;E O F "".""]
	[Array : .  ""{"" Statements ""}"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Variable : .  <name>;""."" <name> <assignment> E O F <binarySymbol> <keyword>]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;""."" E O F "";"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <multikeyword>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <name>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Primary : .  Variable;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <keyword>;<name> E O F ""."" <keyword> <binarySymbol>]
	[MessageSend : .  UnaryMessageSend;E O F "";"" "".""]
	[Temporaries : .  ""||"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""false"" E O F <negativeNumber> ""^""]
	[MessageSend : .  BinaryMessageSend;E O F "";"" "".""]
	[Assignment : .  Variable <assignment> Expression;E O F "".""]
	[KeywordMessageSend : .  UnaryMessageSend KeywordMessage;E O F "";"" "".""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;"";"" ""."" <name> E O F <binarySymbol> <keyword>]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Annotations : Annotations .  Annotation;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]
	[MessageSend : .  KeywordMessageSend;E O F "";"" "".""]
	[Temporaries : .  ""|"" TemporaryVariables ""|"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""false"" E O F <negativeNumber> ""^""]
	[Primary : .  Array;<name> E O F ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" Sequence ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Sequence : .  Temporaries Statements;E O F]
	[Primary : .  ""("" Expression "")"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Annotation : .  ""<"" KeywordMessage "">"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]
	[Literal : .  ""#"" ""["" ByteArray ""]"";<name> E O F ""."" <keyword> <binarySymbol>]

52	[Method : MethodPattern Sequence . ;E O F]

53	[Optional: ""."" : . ;E O F ""]"" ""}""]
	[Optional: ""."" : .  ""."";E O F ""]"" ""}""]
	[Statements : ""^"" Expression .  Optional: ""."";E O F ""]"" ""}""]

54	[BlockArgs : "":"" .  Argument;"":"" ""|"" ""]"" ""||""]
	[Argument : .  <name>;"":"" ""|"" ""]"" ""||""]

55	[Block : ""["" BlockArgs .  ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Block : ""["" BlockArgs .  ""||"" TemporaryVariables ""|"" Statements ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[BlockArgs : BlockArgs .  "":"" Argument;"":"" ""|"" ""]"" ""||""]
	[Block : ""["" BlockArgs .  ""|"" Sequence ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]

56	[Block : ""["" Sequence .  ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]

57	[TemporaryVariables : TemporaryVariables .  Variable;<name> ""|""]
	[Variable : .  <name>;<name> ""|""]
	[Temporaries : ""|"" TemporaryVariables .  ""|"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""false"" E O F <negativeNumber> ""]"" ""^""]

58	[Literal : ""#"" ""["" .  ByteArray ""]"";<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]
	[ByteArray : .  ByteArray <number>;""]"" <number>]
	[ByteArray : . ;""]"" <number>]

59	[Literal : ""#"" ""("" .  LiteralArray "")"";<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]
	[LiteralArray : .  LiteralArray ArrayLiteral;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[LiteralArray : . ;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]

60	[Literal : ""#"" <string> . ;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

61	[Literal : ""#"" <name> . ;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

62	[Literal : ""#"" <keyword> . ;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

63	[Literal : ""#"" <multikeyword> . ;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

64	[Literal : ""#"" <binarySymbol> . ;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

65	[Literal : ""#"" <alternateKeyword> . ;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

66	[Primary : ""("" Expression .  "")"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]

67	[Array : ""{"" Statements .  ""}"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]

68	[Cascade : .  Cascade "";"" Message;""}"" "";"" ""."" E O F ""]"" "")""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Block : .  ""["" BlockArgs ""]"";"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Literal : .  ""false"";"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Cascade : .  MessageSend;""}"" "";"" ""."" E O F ""]"" "")""]
	[Assignment : Variable <assignment> .  Expression;""}"" E O F ""]"" ""."" "")""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Primary : .  Literal;""}"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> "")""]
	[UnaryMessageSend : .  Primary UnaryMessage;""}"" "";"" ""."" <name> E O F ""]"" <binarySymbol> <keyword> "")""]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;""}"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "")""]
	[Literal : .  <negativeNumber>;"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Literal : .  ""#"" <string>;"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Literal : .  <number>;"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[BinaryMessageSend : .  Primary BinaryMessage;""}"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "")""]
	[Literal : .  ""#"" <binarySymbol>;"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[KeywordMessageSend : .  Primary KeywordMessage;""}"" "";"" ""."" E O F ""]"" "")""]
	[Literal : .  ""true"";"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Expression : .  Primary;""."" E O F ""]"" "")"" ""}""]
	[KeywordMessageSend : .  BinaryMessageSend KeywordMessage;""}"" "";"" ""."" E O F ""]"" "")""]
	[Literal : .  ""#"" <alternateKeyword>;"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Literal : .  <character>;"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Expression : .  Assignment;""."" E O F ""]"" "")"" ""}""]
	[Literal : .  ""nil"";"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Primary : .  Block;""}"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> "")""]
	[Literal : .  <string>;"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Expression : .  Cascade;""."" E O F ""]"" "")"" ""}""]
	[Array : .  ""{"" Statements ""}"";"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Variable : .  <name>;""."" "")"" <binarySymbol> <name> <assignment> E O F ""]"" <keyword> ""}""]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;""}"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "")""]
	[Literal : .  ""#"" <multikeyword>;"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Literal : .  ""#"" <name>;"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Primary : .  Variable;""}"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> "")""]
	[Literal : .  ""#"" <keyword>;"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[MessageSend : .  UnaryMessageSend;"")"" "";"" ""."" E O F ""]"" ""}""]
	[MessageSend : .  BinaryMessageSend;"")"" "";"" ""."" E O F ""]"" ""}""]
	[Assignment : .  Variable <assignment> Expression;"")"" E O F ""]"" ""}"" "".""]
	[KeywordMessageSend : .  UnaryMessageSend KeywordMessage;""}"" "";"" ""."" E O F ""]"" "")""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;""}"" "";"" ""."" <name> E O F ""]"" <binarySymbol> <keyword> "")""]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[MessageSend : .  KeywordMessageSend;"")"" "";"" ""."" E O F ""]"" ""}""]
	[Block : .  ""["" Sequence ""]"";"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Primary : .  Array;""}"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> "")""]
	[Primary : .  ""("" Expression "")"";""}"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> "")""]
	[Literal : .  ""#"" ""["" ByteArray ""]"";"")"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]

69	[Cascade : .  Cascade "";"" Message;""."" E O F ""]"" "";"" ""}""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Block : .  ""["" BlockArgs ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  ""false"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Cascade : .  MessageSend;""."" E O F ""]"" "";"" ""}""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Primary : .  Literal;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[UnaryMessageSend : .  Primary UnaryMessage;"";"" ""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;"";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]
	[Literal : .  <negativeNumber>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  ""#"" <string>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  <number>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[BinaryMessageSend : .  Primary BinaryMessage;"";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" <binarySymbol>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[KeywordMessageSend : .  Primary KeywordMessage;""."" E O F ""]"" "";"" ""}""]
	[Literal : .  ""true"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Expression : .  Primary;""}"" E O F ""]"" "".""]
	[KeywordMessageSend : .  BinaryMessageSend KeywordMessage;""."" E O F ""]"" "";"" ""}""]
	[Literal : .  ""#"" <alternateKeyword>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  <character>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Expression : .  Assignment;""}"" E O F ""]"" "".""]
	[Literal : .  ""nil"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Primary : .  Block;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  <string>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Expression : .  Cascade;""}"" E O F ""]"" "".""]
	[Array : .  ""{"" Statements ""}"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Variable : .  <name>;""}"" ""."" <name> <assignment> E O F <binarySymbol> <keyword> ""]""]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;"";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" <multikeyword>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  ""#"" <name>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Primary : .  Variable;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  ""#"" <keyword>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[MessageSend : .  UnaryMessageSend;""}"" E O F ""]"" "";"" "".""]
	[StatementList : StatementList ""."" .  Expression;""."" E O F ""]"" ""}""]
	[Statements : StatementList ""."" .  ""^"" Expression Optional: ""."";E O F ""]"" ""}""]
	[MessageSend : .  BinaryMessageSend;""}"" E O F ""]"" "";"" "".""]
	[Assignment : .  Variable <assignment> Expression;""."" E O F ""]"" ""}""]
	[Optional: ""."" : ""."" . ;E O F ""]"" ""}""]
	[KeywordMessageSend : .  UnaryMessageSend KeywordMessage;""."" E O F ""]"" "";"" ""}""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;"";"" ""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[MessageSend : .  KeywordMessageSend;""}"" E O F ""]"" "";"" "".""]
	[Block : .  ""["" Sequence ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Primary : .  Array;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Primary : .  ""("" Expression "")"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  ""#"" ""["" ByteArray ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]

70	[Statements : StatementList Optional: ""."" . ;E O F ""]"" ""}""]

71	[UnaryMessage : .  <name>;""}"" "";"" ""."" E O F ""]"" "")""]
	[KeywordMessage : .  <keyword> KeywordArgument;""}"" "";"" ""."" E O F ""]"" <keyword> "")""]
	[Message : .  UnaryMessage;""}"" "";"" ""."" E O F ""]"" "")""]
	[KeywordMessage : .  KeywordMessage <keyword> KeywordArgument;""}"" "";"" ""."" E O F ""]"" <keyword> "")""]
	[Message : .  KeywordMessage;""}"" "";"" ""."" E O F ""]"" "")""]
	[Message : .  BinaryMessage;""}"" "";"" ""."" E O F ""]"" "")""]
	[Cascade : Cascade "";"" .  Message;""}"" "";"" ""."" E O F ""]"" "")""]
	[BinaryMessage : .  <binarySymbol> BinaryArgument;""}"" "";"" ""."" E O F ""]"" "")""]

72	[UnaryMessage : <name> . ;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]

73	[Literal : .  ""nil"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  ""#"" <alternateKeyword>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  ""#"" ""["" ByteArray ""]"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Block : .  ""["" BlockArgs ""]"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[KeywordArgument : .  UnaryMessageSend;""}"" "">"" "";"" ""."" E O F ""]"" <keyword> "")""]
	[Literal : .  ""false"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  <string>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Array : .  ""{"" Statements ""}"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Primary : .  Literal;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;""}"" "">"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "")""]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;"")"" "">"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]
	[UnaryMessageSend : .  Primary UnaryMessage;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  <negativeNumber>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  ""#"" <string>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  ""#"" <name>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  <number>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  ""#"" <keyword>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  ""#"" <binarySymbol>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  ""#"" <multikeyword>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Primary : .  Variable;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Variable : .  <name>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[BinaryMessageSend : .  Primary BinaryMessage;""}"" "">"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "")""]
	[KeywordArgument : .  Primary;""}"" "">"" "";"" ""."" E O F ""]"" <keyword> "")""]
	[KeywordArgument : .  BinaryMessageSend;""}"" "">"" "";"" ""."" E O F ""]"" <keyword> "")""]
	[KeywordMessage : <keyword> .  KeywordArgument;"")"" "">"" "";"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  ""true"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Primary : .  Array;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Block : .  ""["" Sequence ""]"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Primary : .  ""("" Expression "")"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Primary : .  Block;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  <character>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]

74	[Literal : .  ""nil"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  ""#"" <alternateKeyword>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  ""#"" ""["" ByteArray ""]"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Block : .  ""["" BlockArgs ""]"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[BinaryArgument : .  Primary;""}"" "">"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "")""]
	[Literal : .  ""false"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  <string>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Array : .  ""{"" Statements ""}"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Primary : .  Literal;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[UnaryMessageSend : .  Primary UnaryMessage;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" <multikeyword>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  <negativeNumber>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  ""#"" <string>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  ""#"" <name>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  ""#"" <keyword>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  <number>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Primary : .  Variable;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" <binarySymbol>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Variable : .  <name>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[BinaryArgument : .  UnaryMessageSend;""}"" "">"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "")""]
	[Literal : .  ""true"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[BinaryMessage : <binarySymbol> .  BinaryArgument;"")"" "">"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]
	[Primary : .  Array;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Block : .  ""["" Sequence ""]"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Primary : .  ""("" Expression "")"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Primary : .  Block;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  <character>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]

75	[KeywordMessage : KeywordMessage .  <keyword> KeywordArgument;"")"" "";"" ""."" E O F ""]"" <keyword> ""}""]
	[KeywordMessageSend : Primary KeywordMessage . ;""}"" "";"" ""."" E O F ""]"" "")""]

76	[UnaryMessageSend : Primary UnaryMessage . ;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]

77	[BinaryMessageSend : Primary BinaryMessage . ;"")"" "">"" "";"" <binarySymbol> ""."" E O F ""]"" <keyword> ""}""]

78	[KeywordMessage : KeywordMessage .  <keyword> KeywordArgument;"")"" "";"" ""."" E O F ""]"" <keyword> ""}""]
	[KeywordMessageSend : BinaryMessageSend KeywordMessage . ;""}"" "";"" ""."" E O F ""]"" "")""]

79	[BinaryMessageSend : BinaryMessageSend BinaryMessage . ;"")"" "">"" "";"" <binarySymbol> ""."" E O F ""]"" <keyword> ""}""]

80	[KeywordMessage : KeywordMessage .  <keyword> KeywordArgument;"")"" "";"" ""."" E O F ""]"" <keyword> ""}""]
	[KeywordMessageSend : UnaryMessageSend KeywordMessage . ;""}"" "";"" ""."" E O F ""]"" "")""]

81	[UnaryMessageSend : UnaryMessageSend UnaryMessage . ;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]

82	[BinaryMessageSend : UnaryMessageSend BinaryMessage . ;"")"" "">"" "";"" <binarySymbol> ""."" E O F ""]"" <keyword> ""}""]

83	[Sequence : Temporaries Statements . ;E O F ""]""]

84	[Annotation : ""<"" KeywordMessage .  "">"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> ""<"" <string> ""#"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]
	[KeywordMessage : KeywordMessage .  <keyword> KeywordArgument;<keyword> "">""]

85	[Annotations : Annotations Annotation . ;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> ""<"" <string> ""#"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]

86	[KeywordMethodPattern : KeywordMethodPattern <keyword> Argument . ;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""||"" ""false"" ""|"" E O F <negativeNumber> <keyword> ""^""]

87	[Cascade : .  Cascade "";"" Message;E O F "";"" "".""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" BlockArgs ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""false"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Cascade : .  MessageSend;E O F "";"" "".""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Primary : .  Literal;<name> E O F ""."" <keyword> <binarySymbol>]
	[UnaryMessageSend : .  Primary UnaryMessage;"";"" ""."" <name> E O F <binarySymbol> <keyword>]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;""."" E O F "";"" <keyword> <binarySymbol>]
	[Literal : .  <negativeNumber>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <string>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Method : MethodPattern Temporaries Annotations .  Statements;E O F]
	[Literal : .  <number>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <binarySymbol>;<name> E O F ""."" <keyword> <binarySymbol>]
	[BinaryMessageSend : .  Primary BinaryMessage;""."" E O F "";"" <keyword> <binarySymbol>]
	[Statements : .  StatementList Optional: ""."";E O F]
	[KeywordMessageSend : .  Primary KeywordMessage;E O F "";"" "".""]
	[Literal : .  ""true"";<name> E O F ""."" <keyword> <binarySymbol>]
	[StatementList : .  StatementList ""."" Expression;E O F "".""]
	[Expression : .  Primary;E O F "".""]
	[Statements : .  StatementList ""."" ""^"" Expression Optional: ""."";E O F]
	[Statements : . ;E O F]
	[KeywordMessageSend : .  BinaryMessageSend KeywordMessage;E O F "";"" "".""]
	[Expression : .  Assignment;E O F "".""]
	[Primary : .  Block;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  <character>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""nil"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <alternateKeyword>;<name> E O F ""."" <keyword> <binarySymbol>]
	[StatementList : .  Expression;E O F "".""]
	[Statements : .  ""^"" Expression Optional: ""."";E O F]
	[Literal : .  <string>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Expression : .  Cascade;E O F "".""]
	[Array : .  ""{"" Statements ""}"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Variable : .  <name>;""."" <name> <assignment> E O F <binarySymbol> <keyword>]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;""."" E O F "";"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <multikeyword>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <name>;<name> E O F ""."" <keyword> <binarySymbol>]
	[Primary : .  Variable;<name> E O F ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <keyword>;<name> E O F ""."" <keyword> <binarySymbol>]
	[MessageSend : .  UnaryMessageSend;E O F "";"" "".""]
	[MessageSend : .  BinaryMessageSend;E O F "";"" "".""]
	[Assignment : .  Variable <assignment> Expression;E O F "".""]
	[KeywordMessageSend : .  UnaryMessageSend KeywordMessage;E O F "";"" "".""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;"";"" ""."" <name> E O F <binarySymbol> <keyword>]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Annotations : Annotations .  Annotation;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""false"" E O F <negativeNumber> ""^""]
	[MessageSend : .  KeywordMessageSend;E O F "";"" "".""]
	[Primary : .  Array;<name> E O F ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" Sequence ""]"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Primary : .  ""("" Expression "")"";<name> E O F ""."" <keyword> <binarySymbol>]
	[Annotation : .  ""<"" KeywordMessage "">"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""false"" E O F <negativeNumber> ""^""]
	[Literal : .  ""#"" ""["" ByteArray ""]"";<name> E O F ""."" <keyword> <binarySymbol>]

88	[Method : MethodPattern Annotations Sequence . ;E O F]

89	[Optional: ""."" : ""."" . ;E O F ""]"" ""}""]

90	[Statements : ""^"" Expression Optional: ""."" . ;E O F ""]"" ""}""]

91	[BlockArgs : "":"" Argument . ;"":"" ""|"" ""]"" ""||""]

92	[Cascade : .  Cascade "";"" Message;""]"" "";"" "".""]
	[Block : ""["" BlockArgs ""|"" .  Sequence ""]"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" BlockArgs ""]"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""false"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Cascade : .  MessageSend;""]"" "";"" "".""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Primary : .  Literal;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[UnaryMessageSend : .  Primary UnaryMessage;"";"" ""."" <name> ""]"" <binarySymbol> <keyword>]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;""."" ""]"" "";"" <keyword> <binarySymbol>]
	[Literal : .  <negativeNumber>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <string>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  <number>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[BinaryMessageSend : .  Primary BinaryMessage;""."" ""]"" "";"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <binarySymbol>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Statements : .  StatementList Optional: ""."";""]""]
	[KeywordMessageSend : .  Primary KeywordMessage;""]"" "";"" "".""]
	[Literal : .  ""true"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Sequence : .  Statements;""]""]
	[StatementList : .  StatementList ""."" Expression;""]"" "".""]
	[Expression : .  Primary;""]"" "".""]
	[Statements : .  StatementList ""."" ""^"" Expression Optional: ""."";""]""]
	[Statements : . ;""]""]
	[KeywordMessageSend : .  BinaryMessageSend KeywordMessage;""]"" "";"" "".""]
	[Expression : .  Assignment;""]"" "".""]
	[Literal : .  <character>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Primary : .  Block;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""nil"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <alternateKeyword>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[StatementList : .  Expression;""]"" "".""]
	[Statements : .  ""^"" Expression Optional: ""."";""]""]
	[Literal : .  <string>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Expression : .  Cascade;""]"" "".""]
	[Array : .  ""{"" Statements ""}"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Variable : .  <name>;""."" <name> <assignment> ""]"" <binarySymbol> <keyword>]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;""."" ""]"" "";"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <multikeyword>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <name>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Primary : .  Variable;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <keyword>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[MessageSend : .  UnaryMessageSend;""]"" "";"" "".""]
	[Temporaries : .  ""||"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""false"" ""]"" <negativeNumber> ""^""]
	[MessageSend : .  BinaryMessageSend;""]"" "";"" "".""]
	[Assignment : .  Variable <assignment> Expression;""]"" "".""]
	[KeywordMessageSend : .  UnaryMessageSend KeywordMessage;""]"" "";"" "".""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;"";"" ""."" <name> ""]"" <binarySymbol> <keyword>]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[MessageSend : .  KeywordMessageSend;""]"" "";"" "".""]
	[Temporaries : .  ""|"" TemporaryVariables ""|"";""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""false"" ""]"" <negativeNumber> ""^""]
	[Primary : .  Array;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" Sequence ""]"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Sequence : .  Temporaries Statements;""]""]
	[Primary : .  ""("" Expression "")"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" ""["" ByteArray ""]"";<name> ""]"" ""."" <keyword> <binarySymbol>]

93	[Block : ""["" BlockArgs ""]"" . ;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]

94	[TemporaryVariables : .  TemporaryVariables Variable;<name> ""|""]
	[TemporaryVariables : . ;<name> ""|""]
	[Block : ""["" BlockArgs ""||"" .  TemporaryVariables ""|"" Statements ""]"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]

95	[BlockArgs : BlockArgs "":"" .  Argument;"":"" ""|"" ""]"" ""||""]
	[Argument : .  <name>;"":"" ""|"" ""]"" ""||""]

96	[Block : ""["" Sequence ""]"" . ;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]

97	[Temporaries : ""|"" TemporaryVariables ""|"" . ;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> <string> ""#"" ""<"" ""false"" E O F <negativeNumber> ""]"" ""^""]

98	[TemporaryVariables : TemporaryVariables Variable . ;<name> ""|""]

99	[ByteArray : ByteArray .  <number>;""]"" <number>]
	[Literal : ""#"" ""["" ByteArray .  ""]"";<character> ""("" ""["" "";"" ""true"" "">"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F ""}""]

100	[Literal : .  ""nil"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  <alternateKeyword>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  ""["" ByteArray ""]"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""false"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  <binarySymbol>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  <string>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  Literal;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : ""#"" ""("" LiteralArray .  "")"";<character> ""("" ""["" "";"" ""true"" "">"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F ""}""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""#"" <multikeyword>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  <negativeNumber>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""#"" <string>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[LiteralArray : LiteralArray .  ArrayLiteral;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""#"" <name>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  <number>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""#"" <keyword>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""#"" <binarySymbol>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  ""("" LiteralArray "")"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  <keyword>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""true"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  <name>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  <multikeyword>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  <anyChar>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""#"" <alternateKeyword>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""#"" ""["" ByteArray ""]"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  <character>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]

101	[Primary : ""("" Expression "")"" . ;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]

102	[Array : ""{"" Statements ""}"" . ;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]

103	[Assignment : Variable <assignment> Expression . ;""."" E O F ""]"" "")"" ""}""]

104	[Cascade : .  Cascade "";"" Message;""}"" E O F ""]"" "";"" "".""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Block : .  ""["" BlockArgs ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  ""false"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Cascade : .  MessageSend;""}"" E O F ""]"" "";"" "".""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Primary : .  Literal;<binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[UnaryMessageSend : .  Primary UnaryMessage;"";"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;"";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]
	[Literal : .  <negativeNumber>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  ""#"" <string>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  <number>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[BinaryMessageSend : .  Primary BinaryMessage;"";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" <binarySymbol>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[KeywordMessageSend : .  Primary KeywordMessage;""}"" E O F ""]"" "";"" "".""]
	[Literal : .  ""true"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Expression : .  Primary;""."" E O F ""]"" ""}""]
	[Statements : StatementList ""."" ""^"" .  Expression Optional: ""."";E O F ""]"" ""}""]
	[KeywordMessageSend : .  BinaryMessageSend KeywordMessage;""}"" E O F ""]"" "";"" "".""]
	[Literal : .  ""#"" <alternateKeyword>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  <character>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Expression : .  Assignment;""."" E O F ""]"" ""}""]
	[Literal : .  ""nil"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Primary : .  Block;<binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Literal : .  <string>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Expression : .  Cascade;""."" E O F ""]"" ""}""]
	[Array : .  ""{"" Statements ""}"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Variable : .  <name>;""}"" <binarySymbol> <name> <assignment> E O F ""]"" <keyword> "".""]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;"";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" <multikeyword>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Literal : .  ""#"" <name>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Primary : .  Variable;<binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Literal : .  ""#"" <keyword>;""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[MessageSend : .  UnaryMessageSend;""."" E O F ""]"" "";"" ""}""]
	[MessageSend : .  BinaryMessageSend;""."" E O F ""]"" "";"" ""}""]
	[Assignment : .  Variable <assignment> Expression;""}"" E O F ""]"" "".""]
	[KeywordMessageSend : .  UnaryMessageSend KeywordMessage;""}"" E O F ""]"" "";"" "".""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;"";"" <binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[MessageSend : .  KeywordMessageSend;""."" E O F ""]"" "";"" ""}""]
	[Block : .  ""["" Sequence ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]
	[Primary : .  Array;<binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Primary : .  ""("" Expression "")"";<binarySymbol> <name> E O F ""]"" ""."" <keyword> ""}""]
	[Literal : .  ""#"" ""["" ByteArray ""]"";""."" <name> E O F ""]"" <binarySymbol> <keyword> ""}""]

105	[StatementList : StatementList ""."" Expression . ;""}"" E O F ""]"" "".""]

106	[KeywordMessage : KeywordMessage .  <keyword> KeywordArgument;"")"" "";"" ""."" E O F ""]"" <keyword> ""}""]
	[Message : KeywordMessage . ;""}"" "";"" ""."" E O F ""]"" "")""]

107	[Cascade : Cascade "";"" Message . ;""}"" "";"" ""."" E O F ""]"" "")""]

108	[Message : UnaryMessage . ;""}"" "";"" ""."" E O F ""]"" "")""]

109	[Message : BinaryMessage . ;""}"" "";"" ""."" E O F ""]"" "")""]

110	[Primary : Variable . ;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]

111	[UnaryMessage : .  <name>;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[BinaryMessageSend : Primary .  BinaryMessage;""}"" "")"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "">""]
	[BinaryMessage : .  <binarySymbol> BinaryArgument;""}"" "">"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "")""]
	[KeywordArgument : Primary . ;""}"" "")"" "";"" ""."" E O F ""]"" <keyword> "">""]
	[UnaryMessageSend : Primary .  UnaryMessage;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]

112	[BinaryMessageSend : BinaryMessageSend .  BinaryMessage;"")"" ""}"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "">""]
	[BinaryMessage : .  <binarySymbol> BinaryArgument;"")"" "">"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]
	[KeywordArgument : BinaryMessageSend . ;""}"" "")"" "";"" ""."" E O F ""]"" <keyword> "">""]

113	[BinaryMessageSend : UnaryMessageSend .  BinaryMessage;""}"" "")"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "">""]
	[UnaryMessage : .  <name>;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[BinaryMessage : .  <binarySymbol> BinaryArgument;""}"" "">"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "")""]
	[UnaryMessageSend : UnaryMessageSend .  UnaryMessage;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[KeywordArgument : UnaryMessageSend . ;""}"" "")"" "";"" ""."" E O F ""]"" <keyword> "">""]

114	[KeywordMessage : <keyword> KeywordArgument . ;"")"" ""}"" "";"" ""."" E O F ""]"" <keyword> "">""]

115	[UnaryMessage : .  <name>;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[BinaryArgument : Primary . ;"")"" "">"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]
	[UnaryMessageSend : Primary .  UnaryMessage;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]

116	[UnaryMessage : .  <name>;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[UnaryMessageSend : UnaryMessageSend .  UnaryMessage;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[BinaryArgument : UnaryMessageSend . ;"")"" "">"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]

117	[BinaryMessage : <binarySymbol> BinaryArgument . ;""}"" "">"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "")""]

118	[Literal : .  ""nil"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" <alternateKeyword>;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" ""["" ByteArray ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Block : .  ""["" BlockArgs ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[KeywordArgument : .  UnaryMessageSend;"")"" "">"" "";"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  ""false"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  <string>;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Array : .  ""{"" Statements ""}"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Primary : .  Literal;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;"")"" "">"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;""}"" "">"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> "")""]
	[UnaryMessageSend : .  Primary UnaryMessage;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  <negativeNumber>;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" <string>;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" <name>;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  <number>;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" <keyword>;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  ""#"" <binarySymbol>;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[KeywordMessage : KeywordMessage <keyword> .  KeywordArgument;""}"" "">"" "";"" ""."" E O F ""]"" <keyword> "")""]
	[Literal : .  ""#"" <multikeyword>;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Primary : .  Variable;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Variable : .  <name>;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[BinaryMessageSend : .  Primary BinaryMessage;"")"" "">"" "";"" ""."" <binarySymbol> E O F ""]"" <keyword> ""}""]
	[KeywordArgument : .  Primary;"")"" "">"" "";"" ""."" E O F ""]"" <keyword> ""}""]
	[KeywordArgument : .  BinaryMessageSend;"")"" "">"" "";"" ""."" E O F ""]"" <keyword> ""}""]
	[Literal : .  ""true"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Primary : .  Array;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Block : .  ""["" Sequence ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[Primary : .  ""("" Expression "")"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Primary : .  Block;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  <character>;"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]

119	[Annotation : ""<"" KeywordMessage "">"" . ;""["" ""("" <character> ""nil"" ""true"" ""{"" <name> <number> ""<"" <string> ""#"" ""||"" ""false"" ""|"" E O F <negativeNumber> ""^""]

120	[Method : MethodPattern Temporaries Annotations Statements . ;E O F]

121	[Block : ""["" BlockArgs ""|"" Sequence .  ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]

122	[Variable : .  <name>;<name> ""|""]
	[Block : ""["" BlockArgs ""||"" TemporaryVariables .  ""|"" Statements ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]
	[TemporaryVariables : TemporaryVariables .  Variable;<name> ""|""]

123	[BlockArgs : BlockArgs "":"" Argument . ;"":"" ""|"" ""]"" ""||""]

124	[Literal : ""#"" ""["" ByteArray ""]"" . ;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

125	[ByteArray : ByteArray <number> . ;""]"" <number>]

126	[ArrayLiteral : ""["" .  ByteArray ""]"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ByteArray : .  ByteArray <number>;""]"" <number>]
	[ByteArray : . ;""]"" <number>]

127	[ArrayLiteral : ""("" .  LiteralArray "")"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[LiteralArray : .  LiteralArray ArrayLiteral;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[LiteralArray : . ;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]

128	[Literal : ""#"" ""("" LiteralArray "")"" . ;<character> ""("" ""["" "";"" ""true"" ""}"" <string> ""#"" "")"" ""false"" <alternateKeyword> ""]"" <negativeNumber> <keyword> <anyChar> ""nil"" <multikeyword> <binarySymbol> <name> <number> ""."" E O F "">""]

129	[ArrayLiteral : <name> . ;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]

130	[ArrayLiteral : <keyword> . ;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]

131	[ArrayLiteral : <multikeyword> . ;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]

132	[ArrayLiteral : <binarySymbol> . ;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]

133	[ArrayLiteral : <alternateKeyword> . ;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]

134	[ArrayLiteral : <anyChar> . ;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]

135	[ArrayLiteral : Literal . ;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]

136	[LiteralArray : LiteralArray ArrayLiteral . ;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]

137	[Optional: ""."" : . ;E O F ""]"" ""}""]
	[Optional: ""."" : .  ""."";E O F ""]"" ""}""]
	[Statements : StatementList ""."" ""^"" Expression .  Optional: ""."";E O F ""]"" ""}""]

138	[KeywordMessage : KeywordMessage <keyword> KeywordArgument . ;""}"" "")"" "";"" ""."" E O F ""]"" <keyword> "">""]

139	[Block : ""["" BlockArgs ""|"" Sequence ""]"" . ;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]

140	[Cascade : .  Cascade "";"" Message;""]"" "";"" "".""]
	[Block : .  ""["" BlockArgs ""|"" Sequence ""]"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" BlockArgs ""]"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""false"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Cascade : .  MessageSend;""]"" "";"" "".""]
	[Literal : .  ""#"" ""("" LiteralArray "")"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Primary : .  Literal;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[UnaryMessageSend : .  Primary UnaryMessage;"";"" ""."" <name> ""]"" <binarySymbol> <keyword>]
	[BinaryMessageSend : .  BinaryMessageSend BinaryMessage;""."" ""]"" "";"" <keyword> <binarySymbol>]
	[Literal : .  <negativeNumber>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <string>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Block : ""["" BlockArgs ""||"" TemporaryVariables ""|"" .  Statements ""]"";""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]
	[Literal : .  <number>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <binarySymbol>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[BinaryMessageSend : .  Primary BinaryMessage;""."" ""]"" "";"" <keyword> <binarySymbol>]
	[Statements : .  StatementList Optional: ""."";""]""]
	[KeywordMessageSend : .  Primary KeywordMessage;""]"" "";"" "".""]
	[Literal : .  ""true"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[StatementList : .  StatementList ""."" Expression;""]"" "".""]
	[Expression : .  Primary;""]"" "".""]
	[Statements : .  StatementList ""."" ""^"" Expression Optional: ""."";""]""]
	[Statements : . ;""]""]
	[KeywordMessageSend : .  BinaryMessageSend KeywordMessage;""]"" "";"" "".""]
	[Literal : .  ""#"" <alternateKeyword>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  <character>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Expression : .  Assignment;""]"" "".""]
	[Literal : .  ""nil"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Primary : .  Block;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[StatementList : .  Expression;""]"" "".""]
	[Statements : .  ""^"" Expression Optional: ""."";""]""]
	[Literal : .  <string>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Expression : .  Cascade;""]"" "".""]
	[Array : .  ""{"" Statements ""}"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Variable : .  <name>;""."" <name> <assignment> ""]"" <binarySymbol> <keyword>]
	[BinaryMessageSend : .  UnaryMessageSend BinaryMessage;""."" ""]"" "";"" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <multikeyword>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <name>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Primary : .  Variable;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" <keyword>;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[MessageSend : .  UnaryMessageSend;""]"" "";"" "".""]
	[MessageSend : .  BinaryMessageSend;""]"" "";"" "".""]
	[Assignment : .  Variable <assignment> Expression;""]"" "".""]
	[KeywordMessageSend : .  UnaryMessageSend KeywordMessage;""]"" "";"" "".""]
	[UnaryMessageSend : .  UnaryMessageSend UnaryMessage;"";"" ""."" <name> ""]"" <binarySymbol> <keyword>]
	[Block : .  ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[MessageSend : .  KeywordMessageSend;""]"" "";"" "".""]
	[Primary : .  Array;<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Block : .  ""["" Sequence ""]"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Primary : .  ""("" Expression "")"";<name> ""]"" ""."" <keyword> <binarySymbol>]
	[Literal : .  ""#"" ""["" ByteArray ""]"";<name> ""]"" ""."" <keyword> <binarySymbol>]

141	[ByteArray : ByteArray .  <number>;""]"" <number>]
	[ArrayLiteral : ""["" ByteArray .  ""]"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]

142	[Literal : .  ""nil"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  <alternateKeyword>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  ""["" ByteArray ""]"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : ""("" LiteralArray .  "")"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""false"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  <binarySymbol>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  <string>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  Literal;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""#"" ""("" LiteralArray "")"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""#"" <multikeyword>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  <negativeNumber>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""#"" <string>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[LiteralArray : LiteralArray .  ArrayLiteral;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""#"" <name>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  <number>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""#"" <keyword>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""#"" <binarySymbol>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  ""("" LiteralArray "")"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  <keyword>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""true"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  <name>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  <multikeyword>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[ArrayLiteral : .  <anyChar>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""#"" <alternateKeyword>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  ""#"" ""["" ByteArray ""]"";<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]
	[Literal : .  <character>;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]

143	[Statements : StatementList ""."" ""^"" Expression Optional: ""."" . ;E O F ""]"" ""}""]

144	[Block : ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements .  ""]"";"">"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> ""}""]

145	[ArrayLiteral : ""["" ByteArray ""]"" . ;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]

146	[ArrayLiteral : ""("" LiteralArray "")"" . ;<character> ""nil"" ""("" ""true"" <multikeyword> <number> <name> <string> ""#"" <binarySymbol> ""["" "")"" ""false"" <alternateKeyword> <anyChar> <negativeNumber> <keyword>]

147	[Block : ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"" . ;""}"" "";"" <binarySymbol> <name> "")"" ""."" E O F ""]"" <keyword> "">""]

"! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
first: nodes

	^ nodes first! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 16:52'!
cascade: nodes
	| cascade |
	(nodes first isKindOf: CMMessage)
		ifTrue: [cascade _ (CMCascade message: nodes first)]
		ifFalse: [cascade _ nodes first].
	cascade
		addMessage: (CMMessage
						receiver: cascade messages first receiver
						selectorParts: nodes third first
						arguments: nodes third last)
		semicolon: nodes second.
	^ cascade! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
valueSymbol: nodes

	^ nodes first value asSymbol! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/26/2004 11:08'!
method: nodes

	^ CMMethod
		selectorParts: nodes first first
		arguments: nodes first last
		body: nodes second! !

SmaCCScanner subclass: #CMScanner
	instanceVariableNames: 'whitespace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Parser'!

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/26/2004 11:52'!
scan2
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(20).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $- 
		ifTrue: 
			[self step.
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(20).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/26/2004 11:52'!
scan7
	self step.
	(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
		ifTrue: 
			[
			[self recordMatch: #(19).
			self step.
			currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
					whileTrue.
			currentCharacter == $. 
				ifTrue: 
					[self step.
					(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
						ifTrue: 
							[
							[self recordMatch: #(19).
							self step.
							currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
									whileTrue.
							currentCharacter == $e ifTrue: [^self scan1].
							^self reportLastMatch].
					^self reportLastMatch].
			currentCharacter == $e ifTrue: [^self scan1].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-tokens' stamp: 'cwp 5/26/2004 11:52'!
negativeNumberId
	^20! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/26/2004 11:52'!
scan3
	
	[self step.
	currentCharacter ~~ $'] whileTrue.
	^self scan4! !

!CMScanner methodsFor: 'generated-tokens' stamp: 'cwp 5/26/2004 11:52'!
nameId
	^22! !

!CMScanner methodsFor: 'scanning' stamp: 'cwp 5/25/2004 02:19'!
flushWhitespace
	| answer |
	answer _ whitespace.
	whitespace _ String new.
	^ answer! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/26/2004 11:52'!
scan9
	self recordMatch: #(23).
	self step.
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) ifTrue: [^self scan5].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-tokens' stamp: 'cwp 5/26/2004 11:52'!
binarySymbolId
	^25! !

!CMScanner methodsFor: 'scanning' stamp: 'cwp 5/25/2004 02:19'!
createTokenFor: string 
	| token |
	token := CMToken
				id: matchActions
				value: string
				whitespace: self flushWhitespace.
	outputStream reset.
	matchActions := nil.
	returnMatchBlock value: token! !

!CMScanner methodsFor: 'generated-tokens' stamp: 'cwp 5/26/2004 11:52'!
emptySymbolTokenId
	^65! !

!CMScanner class methodsFor: 'generated-comments' stamp: 'cwp 5/26/2004 11:52'!
scannerDefinitionComment

	"<decimalNumber>:	[0-9]+ (\. [0-9]+)? ;
<radixNumber>:		[0-9]+ r [0-9A-Z]+ (\. [0-9A-Z]+)? ;
<exponentNumber>:	(<decimalNumber> | <radixNumber>) e \-? [0-9]+ ;
<number>:			<decimalNumber> | <radixNumber> | <exponentNumber> ;
<negativeNumber>:	\- <number> ;
<string>:				\'  [^\']* \' (\' [^\']* \')* ;
<name>:				[a-zA-Z] [a-zA-Z0-9]* ;
<keyword>:			<name> \: ;
<multikeyword>:		<name> \: (<name> \: )+ ;
<binarySymbol>:		[\~\-\!!\@\%\&\*\+\=\\\|\?\/\>\<\,] [\~\!!\@\%\&\*\+\=\\\|\?\/\>\<\,]* ;
<assignment>:		\: = | \_ ;
<alternateKeyword>:	\: <name> \: (<name> \:)* ;
<whitespace>:		\s+ ;
<comment>:			\"" [^\""]* \"" ;
<character>:			\$ . ;
<variableAssignment>:	<name> \: \= ;

<anyChar>:			. ; # For VW literal arrays that handle #(;) -> #(#';')

"! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/26/2004 11:52'!
scan4
	self recordMatch: #(21).
	self step.
	currentCharacter == $' ifTrue: [^self scan3].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/26/2004 11:52'!
scan5
	
	[self step.
	currentCharacter isDigit or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(24).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^self scan5].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner class methodsFor: 'generated-initialization' stamp: 'cwp 5/26/2004 11:52'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(22 'false' 11) #(22 'nil' 12) #(22 'true' 13)) do: 
			[:each | 
			(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
				put: each last].
	^keywordMap! !

!CMScanner methodsFor: 'scanning' stamp: 'cwp 5/25/2004 02:23'!
whitespace 
	whitespace := whitespace, outputStream contents.

	self resetScanner.
	self scanForToken! !

!CMScanner methodsFor: 'generated-tokens' stamp: 'cwp 5/26/2004 11:52'!
errorTokenId
	^66! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/26/2004 11:52'!
scan6
	
	[self step.
	currentCharacter isDigit or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(27).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^self scan6].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'initialize-release' stamp: 'cwp 5/24/2004 21:15'!
initialize
	super initialize.
	whitespace _ ''! !

!CMScanner methodsFor: 'scanning' stamp: 'cwp 5/25/2004 02:18'!
resetScanner
	^ super resetScanner! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/26/2004 11:52'!
scanForToken
	self step.
	(currentCharacter <= $ or: 
			[(currentCharacter between: $ and: $) 
				or: [currentCharacter == $` or: [currentCharacter >= $]]]) 
		ifTrue: [^self recordAndReportMatch: #(31)].
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) 
			ifTrue: 
				[self recordMatch: #(22 31).
				self step.
				(currentCharacter isDigit or: 
						[(currentCharacter between: $A and: $Z) 
							or: [currentCharacter between: $a and: $z]]) 
					ifTrue: 
						[
						[self recordMatch: #(22).
						self step.
						currentCharacter isDigit or: 
								[(currentCharacter between: $A and: $Z) 
									or: [currentCharacter between: $a and: $z]]] 
								whileTrue.
						currentCharacter == $: ifTrue: [^self scan9].
						^self reportLastMatch].
				currentCharacter == $: ifTrue: [^self scan9].
				^self reportLastMatch].
	(currentCharacter == $!! or: 
			[(currentCharacter between: $% and: $&) or: 
					[(currentCharacter between: $* and: $,) or: 
							[currentCharacter == $/ or: 
									[currentCharacter == $= or: 
											[(currentCharacter between: $? and: $@) 
												or: [currentCharacter == $\ or: [currentCharacter == $~]]]]]]]) 
		ifTrue: 
			[self recordMatch: #(25 31).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(25).
					self step.
					currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter isDigit 
		ifTrue: 
			[self recordMatch: #(19 31).
			self step.
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(19).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					currentCharacter == $. ifTrue: [^self scan8].
					currentCharacter == $e ifTrue: [^self scan1].
					currentCharacter == $r ifTrue: [^self scan7].
					^self reportLastMatch].
			currentCharacter == $. ifTrue: [^self scan8].
			currentCharacter == $e ifTrue: [^self scan1].
			currentCharacter == $r ifTrue: [^self scan7].
			^self reportLastMatch].
	(currentCharacter isSeparator or: [currentCharacter == $]) 
		ifTrue: 
			[self recordMatch: #whitespace.
			self step.
			(currentCharacter isSeparator or: [currentCharacter == $]) 
				ifTrue: 
					[
					[self recordMatch: #whitespace.
					self step.
					currentCharacter isSeparator or: [currentCharacter == $]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $" 
		ifTrue: 
			[self recordMatch: #(31).
			self step.
			currentCharacter ~~ $" 
				ifTrue: 
					[
					[self step.
					currentCharacter ~~ $"] whileTrue.
					^self recordAndReportMatch: #comment].
			currentCharacter == $" ifTrue: [^self recordAndReportMatch: #comment].
			^self reportLastMatch].
	currentCharacter == $# ifTrue: [^self recordAndReportMatch: #(4 31)].
	currentCharacter == $$ 
		ifTrue: 
			[self recordMatch: #(31).
			self step.
			^self recordAndReportMatch: #(30)].
	currentCharacter == $' 
		ifTrue: 
			[self recordMatch: #(31).
			self step.
			currentCharacter ~~ $' ifTrue: [^self scan3].
			currentCharacter == $' ifTrue: [^self scan4].
			^self reportLastMatch].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(14 31)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(17 31)].
	currentCharacter == $- 
		ifTrue: 
			[self recordMatch: #(25 31).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(25).
					self step.
					currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(20).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					currentCharacter == $. 
						ifTrue: 
							[self step.
							currentCharacter isDigit 
								ifTrue: 
									[
									[self recordMatch: #(20).
									self step.
									currentCharacter isDigit] 
											whileTrue.
									currentCharacter == $e ifTrue: [^self scan2].
									^self reportLastMatch].
							^self reportLastMatch].
					currentCharacter == $e ifTrue: [^self scan2].
					currentCharacter == $r 
						ifTrue: 
							[self step.
							(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
								ifTrue: 
									[
									[self recordMatch: #(20).
									self step.
									currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
											whileTrue.
									currentCharacter == $. 
										ifTrue: 
											[self step.
											(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
												ifTrue: 
													[
													[self recordMatch: #(20).
													self step.
													currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
															whileTrue.
													currentCharacter == $e ifTrue: [^self scan2].
													^self reportLastMatch].
											^self reportLastMatch].
									currentCharacter == $e ifTrue: [^self scan2].
									^self reportLastMatch].
							^self reportLastMatch].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $. ifTrue: [^self recordAndReportMatch: #(9 31)].
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(10 31).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^self scan6].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(26)].
			^self reportLastMatch].
	currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(18 31)].
	currentCharacter == $< 
		ifTrue: 
			[self recordMatch: #(6 25 31).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(25).
					self step.
					currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $> 
		ifTrue: 
			[self recordMatch: #(7 25 31).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(25).
					self step.
					currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $[ ifTrue: [^self recordAndReportMatch: #(2 31)].
	currentCharacter == $] ifTrue: [^self recordAndReportMatch: #(5 31)].
	currentCharacter == $^ ifTrue: [^self recordAndReportMatch: #(1 31)].
	currentCharacter == $_ ifTrue: [^self recordAndReportMatch: #(26 31)].
	currentCharacter == ${ ifTrue: [^self recordAndReportMatch: #(16 31)].
	currentCharacter == $| 
		ifTrue: 
			[self recordMatch: #(3 25 31).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) 
												or: [currentCharacter == $\ or: [currentCharacter == $~]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(25).
					self step.
					currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			currentCharacter == $| 
				ifTrue: 
					[self recordMatch: #(8 25).
					self step.
					(currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
						ifTrue: 
							[
							[self recordMatch: #(25).
							self step.
							currentCharacter == $!! or: 
									[(currentCharacter between: $% and: $&) or: 
											[(currentCharacter between: $* and: $,) or: 
													[currentCharacter == $/ or: 
															[(currentCharacter between: $< and: $@) or: 
																	[currentCharacter == $\ 
																		or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
									whileTrue.
							^self reportLastMatch].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $} ifTrue: [^self recordAndReportMatch: #(15 31)].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/26/2004 11:52'!
scan8
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(19).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			currentCharacter == $e ifTrue: [^self scan1].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/26/2004 11:52'!
scan1
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(19).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $- 
		ifTrue: 
			[self step.
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(19).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'scanning' stamp: 'cwp 5/24/2004 21:05'!
scannerError
	(stream atEnd and: [start == (stream position + 1)]) 
		ifTrue: 
			[returnMatchBlock value: (CMToken 
										id: (Array with: self emptySymbolTokenId)
										value: ''
										whitespace: '')].
	stream position: start - 1.
	returnMatchBlock value: (CMToken 
								id: #(0)
								value: (String with: stream next)
								whitespace: '')
! !

PackageInfo subclass: #CMPackageMirror
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Utilities'!

!CMPackageMirror methodsFor: 'listing' stamp: 'cwp 5/26/2004 16:46'!
classes
	^ model classes collect: [:ea | Smalltalk at: ea name]! !

!CMPackageMirror methodsFor: 'listing' stamp: 'cwp 5/26/2004 20:53'!
methods
	| closure methods |
	methods _ Set new.
	model classes do: [:class | 
					closure _ [:m | methods add: m asMethodReference].
					class instanceMethods do: closure.
					class classMethods do: closure].
	^ methods asArray! !

!CMPackageMirror methodsFor: 'accessing' stamp: 'cwp 5/26/2004 16:35'!
model: aPackageNode
	model _ aPackageNode! !

!CMPackageMirror methodsFor: 'accessing' stamp: 'cwp 5/26/2004 16:39'!
packageName
	^ model name! !

!CMPackageMirror class methodsFor: 'as yet unclassified' stamp: 'cwp 5/26/2004 16:38'!
forInfo: aPackageInfo
	^ self new model: (CMPackageImporter importFromPackageInfo: aPackageInfo)! !

Object subclass: #CMToken
	instanceVariableNames: 'id value whitespace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Parser'!

!CMToken methodsFor: 'accessing' stamp: 'cwp 5/24/2004 20:49'!
value
	^ value! !

!CMToken methodsFor: 'accessing' stamp: 'cwp 5/24/2004 20:49'!
id
	^ id! !

!CMToken methodsFor: 'accessing' stamp: 'cwp 5/24/2004 20:49'!
whitespace
	^ whitespace! !

!CMToken methodsFor: 'printing' stamp: 'cwp 5/24/2004 21:23'!
printOn: aStream
	aStream nextPutAll: 'CMToken<'.
	self value printOn: aStream.
	aStream nextPut: $>.! !

!CMToken class methodsFor: 'instance creation' stamp: 'cwp 5/24/2004 21:07'!
id: anInteger value: anObject whitespace: aString
	^ self new id: anInteger value: anObject whitespace: aString! !

!CMToken methodsFor: 'initializing' stamp: 'cwp 5/24/2004 20:48'!
id: anInteger value: anObject whitespace: aString
	id _ anInteger.
	value _ anObject.
	whitespace _ aString.! !

!CMToken methodsFor: 'testing' stamp: 'cwp 5/25/2004 01:57'!
isToken
	^ true! !

Object subclass: #CMPackageImporter
	instanceVariableNames: 'package class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Utilities'!

!CMPackageImporter class methodsFor: 'importing' stamp: 'cwp 5/20/2004 22:39'!
importFromPackageInfo: aPackageInfo
	| importer |
	importer _ self new.
	^ importer importPackage: aPackageInfo.
	! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 5/20/2004 22:46'!
importClassInstVar: name
	class addClassInstanceVariable: (CMInstanceVariable named: name)! !

!CMPackageImporter class methodsFor: 'importing' stamp: 'cwp 5/20/2004 17:00'!
import: aPackageName
	^ self importFromPackageInfo: (PackageInfo named: aPackageName)! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 5/21/2004 21:22'!
importClass: aClass
	class _ CMClass named: aClass name.
	class superName: aClass superclass name.
	class format: aClass typeOfClass.
	aClass instVarNames do: [:ea | self importInstVar: ea].
	aClass classVarNames asSortedCollection do: [:ea | self importClassVar: ea].
	aClass class instVarNames do: [:ea | self importClassInstVar: ea].
	aClass sharedPoolsString substrings do: [:ea | self importPoolImport: ea].
	package addClass: class! !

!CMPackageImporter methodsFor: 'accessing' stamp: 'cwp 5/20/2004 17:00'!
package
	^package! !

!CMPackageImporter methodsFor: 'accessing' stamp: 'cwp 5/20/2004 17:00'!
package: anObject
	package := anObject! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 5/20/2004 22:48'!
importPoolImport: name
	class addPoolImport: (CMPoolImport named: name)! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 5/20/2004 22:44'!
importClassVar: name
	class addClassVariable: (CMSharedVariable named: name)! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 5/22/2004 14:27'!
importPackage: aPackageInfo
	package _ CMPackage named: aPackageInfo packageName.
	aPackageInfo classes do: [:ea | self importClass: ea.
							(aPackageInfo coreMethodsForClass: ea) 
								do: [:each| self importMethod: each].
							(aPackageInfo coreMethodsForClass: ea class) 
								do: [:each| self importMethod: each]].
	^ package! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 5/20/2004 22:44'!
importInstVar: name
	 class addInstanceVariable: (CMInstanceVariable named: name)! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 5/26/2004 20:41'!
importMethod: ref
	| method |
	method _ CMParser parseMethod: ((ref actualClass sourceCodeAt: ref methodSymbol) 
											asString withSqueakLineEndings).
	ref classIsMeta
		ifTrue: [class addClassMethod: method]
		ifFalse: [class addInstanceMethod: method]! !

Object subclass: #CMGuide
	instanceVariableNames: 'visitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:26'!
visitReturn: aNode
	visitor visitReturn: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:22'!
visitAssignment: aNode
	visitor visitAssignment: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:11'!
visitNode: aNode
	visitor visitNode: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/26/2004 15:04'!
visitAnnotation: aNode
	visitor visitAnnotation: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:26'!
visitSharedVariable: aNode
	visitor visitSharedVariable: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 15:49'!
visitToken: aToken
	aToken ifNotNil: [visitor visitToken: aToken]! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:26'!
visitSequence: aNode
	visitor visitSequence: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:27'!
visitVariableReference: aNode
	visitor visitVariableReference: aNode! !

!CMGuide methodsFor: 'accessing' stamp: 'cwp 5/25/2004 00:47'!
visitor: aVisitor
	visitor _ aVisitor! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:25'!
visitMethod: aNode
	visitor visitMethod: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:23'!
visitInstanceVariable: aNode
	visitor visitInstanceVariable: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:23'!
visitLiteral: aNode
	visitor visitLiteral: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:23'!
visitCascade: aNode
	visitor visitCascade: aNode! !

CMGuide subclass: #CMTokenGuide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 15:50'!
visitLiteral: literal
	self visitValue: literal in: [self visitToken: literal token]! !

!CMTokenGuide methodsFor: 'private' stamp: 'cwp 5/26/2004 14:55'!
visitKeywordMessagePattern: pattern
	pattern selectorParts 
				with: pattern arguments
				do: [:part :arg | self visitToken: part. self visit: arg]! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 15:52'!
visitBlock: node
	self visitValue: node
		in: [self visitToken: node leftBracket.
			node arguments do: [:ea | self visitArgument: ea].
			node bar ifNotNilDo: [:bar | self visitToken: bar].
			self visitSequence: node body.
			self visitToken: node rightBracket]! !

!CMTokenGuide methodsFor: 'private' stamp: 'cwp 5/25/2004 15:48'!
visitValue: value in: aBlock
	self visitToken: value leftParen.
	aBlock value.
	self visitToken: value rightParen! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 19:34'!
visitAssignment: node
	self visitValue: node in: [self visit: node variable.
							self visitToken: node operator.
							self visit: node value]! !

!CMTokenGuide methodsFor: 'private' stamp: 'cwp 5/26/2004 14:54'!
visitUnaryMessagePattern: pattern
	self visitToken: pattern selectorParts first! !

!CMTokenGuide methodsFor: 'private' stamp: 'cwp 5/25/2004 12:18'!
visitStatements: statements andPeriods: periods
	periods ifNil: [statements do: [:ea | self visit: ea] separatedBy: [visitor visitToken: self period]. 
					^ self].
			
	1 to: periods size do: [:i | 
						self visit: (statements at: i).
						self visitToken: (periods at: i)].
	statements size > periods size ifTrue: [self visit: statements last]! !

!CMTokenGuide methodsFor: 'private' stamp: 'cwp 5/26/2004 14:55'!
visitBinaryMessagePattern: pattern
	self visitToken: pattern selectorParts first.
	self visit: pattern arguments first! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 15:53'!
visitMessage: message
	self visitValue: message
		in: [self visit: message receiver.
			self visitMessageParts: message selectorParts andArguments: message arguments]! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 13:23'!
visitArray: node
	self visitToken: node leftBrace.
	self visitStatements: node statements andPeriods: node periods.
	self visitToken: node rightBrace! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/26/2004 12:30'!
visitMethod: method
	self visitMessagePattern: method.
	method annotations do: [:ea | self visitAnnotation: ea].
	self visitSequence: method body.! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 14:43'!
visitArgument: node
	node colon ifNotNilDo: [:colon | self visitToken: colon].
	self visitToken: node identifier.! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 12:09'!
visitSequence: sequence
	sequence leftBar ifNotNilDo: [:bar | self visitToken: bar].
	sequence temporaries ifNotNilDo: [:temps | temps do: [:ea | self visitVariableReference: ea]].
	sequence rightBar ifNotNilDo: [:bar | self visitToken: bar].
	self visitStatements: sequence statements andPeriods: sequence periods.! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/26/2004 15:06'!
visitAnnotation: aNode
	self visitValue: aNode in: [self visitMessagePattern: aNode]! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 16:58'!
visitCascade: cascade
	self visit: cascade messages first.
	1 	to: cascade semicolons size 
		do: [:i | | semicolon message |
			semicolon _ (cascade semicolons at: i).
			message _ (cascade messages at: i + 1).
			self visitToken: semicolon.
			self visitMessageParts: message selectorParts andArguments: message arguments]! !

!CMTokenGuide methodsFor: 'private' stamp: 'cwp 5/26/2004 12:28'!
visitMessagePattern: messagePattern
	messagePattern isUnary ifTrue: [^ self visitUnaryMessagePattern: messagePattern].
	messagePattern isBinary ifTrue: [^ self visitBinaryMessagePattern: messagePattern].
	messagePattern isKeyword ifTrue: [^ self visitKeywordMessagePattern: messagePattern]! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 02:11'!
visitReturn: node
	self visitToken: node return.
	self visit: node value.! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 15:46'!
visitVariableReference: node
	self visitValue: node in: [self visitToken: node identifier].! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:26'!
visitPoolImport: aNode
	visitor visitPoolImport: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:22'!
visitArray: aNode
	visitor visitArray: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 14:23'!
visitArgument: anArgument
	visitor visitArgument: anArgument! !

!CMGuide class methodsFor: 'guiding' stamp: 'cwp 5/25/2004 01:01'!
guide: aVisitor through: aNode
	| guide |
	guide _ self new.
	guide visitor: aVisitor.
	guide visit: aNode! !

!CMGuide methodsFor: 'guiding' stamp: 'cwp 5/25/2004 00:49'!
visit: aNode
	aNode acceptGuide: self! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:26'!
visitPackage: aNode
	visitor visitPackage: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:23'!
visitBlock: aNode
	visitor visitBlock: aNode! !

!CMGuide methodsFor: 'private' stamp: 'cwp 5/25/2004 02:37'!
visitMessageParts: parts andArguments: arguments
	parts size = 1
		ifTrue: [self visitToken: parts first.
				arguments isEmpty not ifTrue: [self visit: arguments first]]
		ifFalse: [parts with: arguments do: [:keyword :arg | 
											self visitToken: keyword. 
											self visit: arg]]! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:24'!
visitMessage: aNode
	visitor visitMessage: aNode! !

Object subclass: #CMNode
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 13:20'!
isMethod
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/14/2004 23:55'!
isClass
	^ false! !

CMNode subclass: #CMValue
	instanceVariableNames: 'leftParen rightParen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMValue methodsFor: 'accessing' stamp: 'cwp 5/25/2004 15:37'!
leftParen: left rightParen: right
	leftParen := left.
	rightParen := right! !

CMValue subclass: #CMBlock
	instanceVariableNames: 'arguments body leftBracket bar rightBracket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:49'!
bar
	^bar! !

!CMBlock class methodsFor: 'instance creation' stamp: 'cwp 5/24/2004 17:19'!
arguments: anArray body: aSequence 
	^ self new arguments: anArray; body: aSequence! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/24/2004 16:56'!
arguments
	^arguments! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:51'!
leftBracket: left rightBracket: right
	leftBracket _ left.
	rightBracket _ right! !

!CMBlock methodsFor: 'testing' stamp: 'cwp 5/24/2004 17:21'!
isBlock	
	^ true! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:50'!
leftBracket
	^ leftBracket! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/24/2004 16:56'!
body: anObject
	body := anObject! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:49'!
bar: anObject
	bar := anObject! !

!CMBlock methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:55'!
acceptGuide: aGuide
	aGuide visitBlock: self! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/24/2004 16:56'!
body
	^body! !

!CMBlock class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 14:02'!
body: aSequence
	^ self arguments: #() body: aSequence! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/24/2004 16:56'!
arguments: anObject
	arguments := anObject! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:50'!
rightBracket
	^ rightBracket! !

!CMValue methodsFor: 'accessing' stamp: 'cwp 5/25/2004 15:36'!
leftParen
	^leftParen! !

!CMValue methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:22'!
isValue
	^ true! !

CMValue subclass: #CMLiteral
	instanceVariableNames: 'token value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMLiteral methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:41'!
token
	^token! !

!CMLiteral methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:41'!
value: anObject
	value := anObject! !

!CMLiteral methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:42'!
value
	^value! !

!CMLiteral class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2004 13:42'!
token: aToken value: anObject
	^ self new token: aToken; value: anObject! !

!CMLiteral methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:41'!
token: anObject
	token := anObject! !

!CMLiteral methodsFor: 'accessing' stamp: 'cwp 5/24/2004 14:33'!
name
	^ self token value! !

!CMLiteral methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:57'!
acceptGuide: aGuide
	aGuide visitLiteral: self! !

!CMLiteral methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:43'!
isLiteral
	^ true! !

CMValue subclass: #CMAssignment
	instanceVariableNames: 'variable operator value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:21'!
variable
	^variable! !

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:21'!
value: anObject
	value := anObject! !

!CMAssignment class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 19:33'!
variable: aVariableReference operator: aToken value: aValue
	^ self new 
		variable: aVariableReference; 
		operator: aToken;
		value: aValue! !

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:21'!
value
	^value! !

!CMAssignment methodsFor: 'testing' stamp: 'cwp 5/24/2004 18:25'!
isAssignment
	^ true! !

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 5/25/2004 19:31'!
operator
	^operator! !

!CMAssignment methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:54'!
acceptGuide: aGuide
	aGuide visitAssignment: self! !

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 5/25/2004 19:31'!
operator: anObject
	operator := anObject! !

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:21'!
variable: anObject
	variable := anObject! !

CMValue subclass: #CMMessagePattern
	instanceVariableNames: 'selectorParts arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMMessagePattern methodsFor: 'testing' stamp: 'cwp 5/26/2004 14:56'!
isUnary
	^ self selector isUnary! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:53'!
arguments
	^arguments! !

CMMessagePattern subclass: #CMAnnotation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMAnnotation methodsFor: 'testing' stamp: 'cwp 5/26/2004 10:54'!
isAnnotation
	^ true! !

!CMAnnotation methodsFor: 'visiting' stamp: 'cwp 5/26/2004 15:03'!
acceptGuide: aGuide
	aGuide visitAnnotation: self! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:52'!
selectorParts: anObject
	selectorParts := anObject! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:53'!
arguments: anObject
	arguments := anObject! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:52'!
selectorParts
	^selectorParts! !

!CMMessagePattern class methodsFor: 'instance creation' stamp: 'cwp 5/26/2004 11:00'!
selectorParts: parts arguments: args
	^ self new
			selectorParts: parts;
			arguments: args! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 5/26/2004 15:06'!
selector
	^ (String streamContents: [:stream | selectorParts do: [:ea | stream nextPutAll: ea value]])
		asSymbol! !

!CMMessagePattern methodsFor: 'testing' stamp: 'cwp 5/26/2004 14:56'!
isKeyword
	^ self selector isKeyword! !

!CMMessagePattern methodsFor: 'testing' stamp: 'cwp 5/26/2004 15:06'!
isBinary
	^ self selector isInfix! !

CMMessagePattern subclass: #CMMessage
	instanceVariableNames: 'receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMMessage methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:35'!
receiver: anObject
	receiver := anObject! !

!CMMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2004 18:39'!
receiver: receiver selectorParts: parts arguments: args
	^ self new
			receiver: receiver;
			selectorParts: parts;
			arguments: args! !

!CMMessage methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:35'!
receiver
	^receiver! !

!CMMessage methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:57'!
acceptGuide: aGuide
	aGuide visitMessage: self! !

!CMMessage methodsFor: 'testing' stamp: 'cwp 5/24/2004 18:47'!
isMessage
	^ true! !

!CMValue methodsFor: 'accessing' stamp: 'cwp 5/25/2004 15:37'!
rightParen
	^ rightParen! !

CMValue subclass: #CMCascade
	instanceVariableNames: 'messages semicolons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMCascade methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:55'!
acceptGuide: aGuide
	aGuide visitCascade: self! !

!CMCascade methodsFor: 'testing' stamp: 'cwp 5/24/2004 18:59'!
isCascade
	^ true! !

!CMCascade methodsFor: 'accessing' stamp: 'cwp 5/25/2004 16:23'!
addMessage: aMessage semicolon: aToken
	messages add: aMessage.
	semicolons add: aToken! !

!CMCascade methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:58'!
messages
	^ messages! !

!CMCascade methodsFor: 'accessing' stamp: 'cwp 5/25/2004 16:30'!
firstMessage: aMessage
	messages _ OrderedCollection with: aMessage.
	semicolons _ OrderedCollection new.! !

!CMCascade class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 16:31'!
message: aMessage
	^ self new firstMessage: aMessage! !

!CMCascade methodsFor: 'accessing' stamp: 'cwp 5/25/2004 16:17'!
semicolons
	^semicolons! !

CMValue subclass: #CMVariableReference
	instanceVariableNames: 'identifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMVariableReference methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:01'!
acceptGuide: aGuide
	aGuide visitVariableReference: self! !

!CMVariableReference methodsFor: 'accessing' stamp: 'cwp 5/24/2004 14:03'!
identifier
	^ identifier! !

!CMVariableReference methodsFor: 'accessing' stamp: 'cwp 5/24/2004 14:03'!
identifier: aToken
	identifier := aToken! !

!CMVariableReference methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:04'!
isVariableReference
	^ true! !

!CMVariableReference methodsFor: 'accessing' stamp: 'cwp 5/24/2004 14:06'!
name
	^ self identifier value! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 15:49'!
isReturn
	^ false! !

!CMNode methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:58'!
acceptGuide: aGuide
	aGuide visitNode: self! !

CMNode subclass: #CMArgument
	instanceVariableNames: 'colon identifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMArgument class methodsFor: 'as yet unclassified' stamp: 'cwp 5/25/2004 14:22'!
identifier: aToken
	^ self colon: nil identifier: aToken! !

!CMArgument class methodsFor: 'as yet unclassified' stamp: 'cwp 5/25/2004 14:21'!
colon: colonToken identifier: idToken
	^ self new
		colon: colonToken;
		identifier: idToken! !

!CMArgument methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:18'!
identifier
	^identifier! !

!CMArgument methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:20'!
name
	^ self identifier value! !

!CMArgument methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:18'!
identifier: anObject
	identifier := anObject! !

!CMArgument methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:18'!
colon
	^colon! !

!CMArgument methodsFor: 'visiting' stamp: 'cwp 5/25/2004 14:22'!
acceptGuide: aGuide
	aGuide visitArgument: self! !

!CMArgument methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:18'!
colon: anObject
	colon := anObject! !

!CMArgument methodsFor: 'testing' stamp: 'cwp 5/25/2004 14:40'!
isArgument
	^ true! !

CMNode subclass: #CMMethod
	instanceVariableNames: 'selectorParts arguments annotations body'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMMethod methodsFor: 'testing' stamp: 'cwp 5/26/2004 14:59'!
isBinary
	^ self selector isInfix! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:08'!
body
	^body! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:07'!
arguments
	^arguments! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:07'!
selectorParts
	^selectorParts! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/25/2004 23:07'!
name
	^ self selector! !

!CMMethod methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:58'!
acceptGuide: aGuide
	aGuide visitMethod: self! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/26/2004 14:58'!
selector
	^ (String streamContents: [:stream | selectorParts do: [:ea | stream nextPutAll: ea value]])
		asSymbol! !

!CMMethod methodsFor: 'testing' stamp: 'cwp 5/26/2004 14:58'!
isKeyword
	^ self selector isKeyword! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:08'!
body: anObject
	body := anObject! !

!CMMethod methodsFor: 'testing' stamp: 'cwp 5/24/2004 13:20'!
isMethod
	^ true! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:09'!
selectorParts: aCollection arguments: aCollection2
	selectorParts := aCollection.
	arguments := aCollection2! !

!CMMethod methodsFor: 'testing' stamp: 'cwp 5/26/2004 14:57'!
isUnary
	^ self selector isUnary! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:58'!
annotations
	^annotations! !

!CMMethod methodsFor: 'converting' stamp: 'cwp 5/26/2004 21:03'!
asMethodReference
	| ref |
	ref _ MethodReference new.
	ref 
		setClassSymbol: self parent name 
		classIsMeta: (parent classMethods includes: self)
		methodSymbol: self selector
		stringVersion: ''.
	^ ref! !

!CMMethod class methodsFor: 'instance creation' stamp: 'cwp 5/26/2004 11:08'!
selectorParts: parts arguments: args annotations: annotations body: sequence
	^ self new
			selectorParts: parts arguments: args;
			annotations: annotations;
			body: sequence! !

!CMMethod class methodsFor: 'instance creation' stamp: 'cwp 5/26/2004 11:09'!
selectorParts: parts arguments: args body: sequence
	^ self selectorParts: parts arguments: args annotations: OrderedCollection new body: sequence! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:58'!
annotations: anObject
	annotations := anObject! !

CMNode subclass: #CMReturn
	instanceVariableNames: 'return value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMReturn class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 02:05'!
return: aToken value: aValueNode
	^ self new return: aToken value: aValueNode! !

!CMReturn methodsFor: 'accessing' stamp: 'cwp 5/24/2004 15:39'!
value
	^ value! !

!CMReturn methodsFor: 'accessing' stamp: 'cwp 5/25/2004 02:08'!
return
	^ return! !

!CMReturn methodsFor: 'testing' stamp: 'cwp 5/24/2004 15:48'!
isReturn
	^ true! !

!CMReturn methodsFor: 'accessing' stamp: 'cwp 5/25/2004 02:04'!
return: aToken value: aValueNode
	return := aToken.
	value := aValueNode! !

!CMReturn methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:59'!
acceptGuide: aGuide
	aGuide visitReturn: self! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 17:21'!
isBlock
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 18:59'!
isCascade
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/25/2004 01:56'!
isToken
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/26/2004 10:54'!
isAnnotation
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/25/2004 14:31'!
isArgument
	^ false! !

!CMNode methodsFor: 'accessing' stamp: 'cwp 5/16/2004 22:22'!
parent: aNode
	parent _ aNode! !

CMNode subclass: #CMPackage
	instanceVariableNames: 'name classes globals pools initializer initializationSequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMPackage methodsFor: 'accessing' stamp: 'cwp 5/14/2004 01:02'!
name: aString 
	name _ aString! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:55'!
initializer
	^ initializer! !

!CMPackage class methodsFor: 'instance creation' stamp: 'cwp 5/20/2004 17:07'!
named: aSymbol
	^ self new name: aSymbol! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:57'!
initializationSequence
	^ initializationSequence! !

!CMPackage methodsFor: 'pools' stamp: 'cwp 5/20/2004 16:54'!
removePool: aPoolNode
	pools ifNil: [^ nil].
	^ pools remove: aPoolNode ifAbsent: [nil]! !

!CMPackage methodsFor: 'pools' stamp: 'cwp 5/20/2004 16:53'!
addPool: aPoolNode
	pools ifNil: [pools _ OrderedCollection new].
	pools add: aPoolNode! !

!CMPackage methodsFor: 'globals' stamp: 'cwp 5/20/2004 16:52'!
removeGlobal: aGlobalNode
	globals ifNil: [^ nil].
	^ globals remove: aGlobalNode ifAbsent: [nil]! !

!CMPackage methodsFor: 'globals' stamp: 'cwp 5/20/2004 16:51'!
addGlobal: aGlobalNode
	globals ifNil: [globals _ OrderedCollection new].
	globals add: aGlobalNode! !

!CMPackage methodsFor: 'globals' stamp: 'cwp 5/20/2004 16:51'!
globals
	^ globals ifNil: [#()]! !

!CMPackage methodsFor: 'classes' stamp: 'cwp 5/20/2004 16:50'!
removeClass: aClassNode
	classes ifNil: [^ nil].
	^ classes remove: aClassNode ifAbsent: [nil]! !

!CMPackage methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:59'!
acceptGuide: aGuide
	aGuide visitPackage: self! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:56'!
hasInitializer
	^ initializer notNil! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:57'!
hasInitializationSequence
	^ initializationSequence notNil! !

!CMPackage methodsFor: 'classes' stamp: 'cwp 5/20/2004 16:46'!
classes
	^ classes ifNil: [#()]! !

!CMPackage methodsFor: 'accessing' stamp: 'cwp 5/16/2004 20:29'!
name
	^ name! !

!CMPackage methodsFor: 'pools' stamp: 'cwp 5/20/2004 16:53'!
pools
	^ pools ifNil: [#()]! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:57'!
initializationSequence: anInitializationSequenceNode
	initializationSequence _ anInitializationSequenceNode! !

!CMPackage methodsFor: 'classes' stamp: 'cwp 5/20/2004 19:25'!
addClass: aClassNode
	classes ifNil: [classes _ OrderedCollection new].
	classes add: aClassNode.
	aClassNode parent: self! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:55'!
initializer: anInitializerNode
	initializer _ anInitializerNode! !

!CMNode methodsFor: 'printing' stamp: 'cwp 5/15/2004 01:23'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $<.
	aStream nextPutAll: self name.
	aStream nextPut: $>! !

!CMNode methodsFor: 'printing' stamp: 'cwp 5/16/2004 20:28'!
name
	^ ''! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 19:08'!
isArray
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:23'!
isValue
	^ false! !

CMNode subclass: #CMClass
	instanceVariableNames: 'name superName format iVars ciVars cVars imports instanceMethods classMethods initialize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMClass methodsFor: 'class inst variables' stamp: 'cwp 5/20/2004 20:57'!
classInstanceVariables
	^ ciVars ifNil: [#()]! !

!CMClass methodsFor: 'instance variables' stamp: 'cwp 5/20/2004 19:10'!
instanceVariables
	^ iVars ifNil: [#()]! !

!CMClass methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:56'!
acceptGuide: aGuide
	aGuide visitClass: self! !

!CMClass methodsFor: 'pool imports' stamp: 'cwp 5/20/2004 21:40'!
removePoolImport: aPoolImportNode
	imports ifNil: [^ #()].
	^ (imports remove: aPoolImportNode ifAbsent: [^ nil]) parent: nil.! !

!CMClass methodsFor: 'class methods' stamp: 'cwp 5/21/2004 21:30'!
addClassMethod: aMethodNode
	classMethods ifNil: [classMethods _ OrderedCollection new].
	classMethods add: aMethodNode.
	aMethodNode parent: self.! !

!CMClass methodsFor: 'class methods' stamp: 'cwp 5/21/2004 21:30'!
removeClassMethod: aMethodNode
	classMethods ifNil: [^ nil].
	^ (classMethods remove: aMethodNode) parent: nil
	! !

!CMClass methodsFor: 'class methods' stamp: 'cwp 5/21/2004 21:30'!
classMethods
	^ classMethods ifNil: [#()]! !

!CMClass methodsFor: 'instance variables' stamp: 'cwp 5/20/2004 19:31'!
removeInstanceVariable: anInstanceVariableNode
	iVars ifNil: [^ nil].
	^ (iVars remove: anInstanceVariableNode ifAbsent: [^ nil]) parent: nil.! !

!CMClass class methodsFor: 'instance creation' stamp: 'cwp 5/15/2004 01:16'!
fromClass: aClass
	^ self new initFromClass: aClass! !

!CMClass methodsFor: 'pool imports' stamp: 'cwp 5/20/2004 21:35'!
poolImports
	^ imports ifNil: [^ #()]! !

!CMClass methodsFor: 'class variables' stamp: 'cwp 5/20/2004 17:12'!
classVariables
	^ cVars ifNil: [#()]! !

!CMClass methodsFor: 'name' stamp: 'cwp 5/20/2004 17:11'!
name: aNameNode
	name _ aNameNode! !

!CMClass class methodsFor: 'instance creation' stamp: 'cwp 5/20/2004 18:54'!
named: aSymbol 
	^ self new name: aSymbol! !

!CMClass methodsFor: 'class variables' stamp: 'cwp 5/20/2004 19:29'!
addClassVariable: aClassVariableNode
	cVars ifNil: [cVars _ OrderedCollection new].
	cVars add: aClassVariableNode.
	aClassVariableNode parent: self.! !

!CMClass methodsFor: 'testing' stamp: 'cwp 5/15/2004 00:59'!
isClass
	^ true! !

!CMClass methodsFor: 'pool imports' stamp: 'cwp 5/20/2004 21:38'!
addPoolImport: aPoolImportNode
	imports ifNil: [imports _ OrderedCollection new].
	imports add: aPoolImportNode.
	aPoolImportNode parent: self.! !

!CMClass methodsFor: 'instance methods' stamp: 'cwp 5/21/2004 21:19'!
removeInstanceMethod: aMethodNode
	instanceMethods ifNil: [^ nil].
	^ (instanceMethods remove: aMethodNode) parent: nil
	! !

!CMClass methodsFor: 'name' stamp: 'cwp 5/20/2004 18:43'!
superName: aNameNode
	superName _ aNameNode! !

!CMClass methodsFor: 'class variables' stamp: 'cwp 5/20/2004 19:30'!
removeClassVariable: aClassVariableNode
	cVars ifNil: [^ nil].
	^ (cVars remove: aClassVariableNode ifAbsent: [^ nil]) parent: nil.! !

!CMClass methodsFor: 'name' stamp: 'cwp 5/20/2004 18:44'!
hasSuperName
	^ superName notNil! !

!CMClass methodsFor: 'name' stamp: 'cwp 5/15/2004 00:49'!
name
	^ name! !

!CMClass methodsFor: 'format' stamp: 'cwp 5/20/2004 18:48'!
format
	^ format! !

!CMClass methodsFor: 'instance methods' stamp: 'cwp 5/21/2004 20:58'!
instanceMethods
	^ instanceMethods ifNil: [#()]! !

!CMClass methodsFor: 'instance methods' stamp: 'cwp 5/21/2004 20:57'!
addInstanceMethod: aMethodNode
	instanceMethods ifNil: [instanceMethods _ OrderedCollection new].
	instanceMethods add: aMethodNode.
	aMethodNode parent: self.! !

!CMClass methodsFor: 'name' stamp: 'cwp 5/20/2004 18:43'!
superName
	^ superName! !

!CMClass methodsFor: 'testing' stamp: 'cwp 5/20/2004 19:16'!
refersTo: anObject
	anObject isBehavior ifFalse: [^ false].
	name = anObject name ifFalse: [^ false].
	superName = anObject superclass name ifFalse: [^ false].
	format = anObject typeOfClass ifFalse: [^ false]. 
	^ true! !

!CMClass methodsFor: 'format' stamp: 'cwp 5/20/2004 18:48'!
format: anInstanceStateNode 
	format := anInstanceStateNode! !

!CMClass methodsFor: 'instance variables' stamp: 'cwp 5/20/2004 19:27'!
addInstanceVariable: anInstanceVariable 
	iVars ifNil: [iVars _ OrderedCollection new].
	iVars add: anInstanceVariable.
	anInstanceVariable parent: self.! !

!CMClass methodsFor: 'class inst variables' stamp: 'cwp 5/20/2004 20:55'!
addClassInstanceVariable: aCIVariableNode
	ciVars ifNil: [ciVars _ OrderedCollection new].
	ciVars add: aCIVariableNode. 
	aCIVariableNode parent: self! !

!CMClass methodsFor: 'class inst variables' stamp: 'cwp 5/20/2004 20:57'!
removeClassInstanceVariable: aCIVariableNode
	ciVars ifNil: [^ nil].
	^ (ciVars remove: aCIVariableNode ifAbsent: [^ nil]) parent: nil.! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/16/2004 20:12'!
isClassVariable
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:04'!
isVariableReference
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 18:25'!
isAssignment
	^ false! !

CMNode subclass: #CMStatementList
	instanceVariableNames: 'statements periods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMStatementList methodsFor: 'accessing' stamp: 'cwp 5/25/2004 11:25'!
periods
	^periods! !

!CMStatementList class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 11:29'!
statements: statements periods: periods
	^ self new statements: statements periods: periods! !

CMStatementList subclass: #CMArray
	instanceVariableNames: 'leftBrace rightBrace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMArray methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:54'!
acceptGuide: aGuide
	aGuide visitArray: self! !

!CMArray methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:20'!
rightBrace
	^rightBrace! !

!CMArray methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:21'!
leftBrace: left rightBrace: right
	leftBrace := left.
	rightBrace := right! !

!CMArray methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:20'!
leftBrace
	^leftBrace! !

!CMArray class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2004 19:07'!
statements: anArray
	^ self new statements: anArray! !

!CMArray methodsFor: 'testing' stamp: 'cwp 5/24/2004 19:08'!
isArray
	^ true! !

!CMStatementList methodsFor: 'accessing' stamp: 'cwp 5/25/2004 11:28'!
statements: aCollection1 periods: aCollection2 
	statements := aCollection1.
	periods := aCollection2.! !

!CMStatementList methodsFor: 'accessing' stamp: 'cwp 5/25/2004 11:25'!
statements
	^statements! !

CMStatementList subclass: #CMSequence
	instanceVariableNames: 'leftBar temporaries rightBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMSequence methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:32'!
isSequence
	^ true! !

!CMSequence class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 11:31'!
temporaries: temps statements: statements
	^ self new temporaries: temps statements: statements! !

!CMSequence methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:00'!
acceptGuide: aGuide
	aGuide visitSequence: self! !

!CMSequence methodsFor: 'accessing' stamp: 'cwp 5/25/2004 01:41'!
rightBar
	^rightBar! !

!CMSequence methodsFor: 'accessing' stamp: 'cwp 5/25/2004 01:53'!
leftBar: left rightBar: right
	leftBar := left.
	rightBar := right! !

!CMSequence class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 11:53'!
temporaries: temps statements: statements periods: periods
	^ (self statements: statements periods: periods) temporaries: temps! !

!CMSequence class methodsFor: 'instance creation' stamp: 'cwp 5/24/2004 14:31'!
statements: statements
	^ self new statements: statements! !

!CMSequence methodsFor: 'accessing' stamp: 'cwp 5/24/2004 14:35'!
temporaries
	^ temporaries! !

!CMSequence methodsFor: 'accessing' stamp: 'cwp 5/25/2004 01:41'!
leftBar
	^leftBar! !

!CMSequence methodsFor: 'accessing' stamp: 'cwp 5/24/2004 14:35'!
temporaries: anObject
	temporaries := anObject! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 18:47'!
isMessage
	^ false! !

CMNode subclass: #CMVariable
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMVariable class methodsFor: 'instance creation' stamp: 'cwp 5/15/2004 22:48'!
named: aSymbol
	^ self new name: aSymbol! !

CMVariable subclass: #CMInstanceVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMInstanceVariable methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:56'!
acceptGuide: aGuide
	aGuide visitInstanceVariable: self! !

!CMInstanceVariable methodsFor: 'testing' stamp: 'cwp 5/16/2004 20:05'!
isInstanceVariable
	^ true! !

!CMVariable methodsFor: 'accessing' stamp: 'cwp 5/15/2004 22:42'!
name
	^ name! !

!CMVariable methodsFor: 'accessing' stamp: 'cwp 5/15/2004 22:49'!
name: aSymbol
	name _ aSymbol! !

CMVariable subclass: #CMSharedVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMSharedVariable methodsFor: 'testing' stamp: 'cwp 5/16/2004 22:23'!
isClassVariable
	^ parent isClass! !

!CMSharedVariable methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:00'!
acceptGuide: aGuide
	aGuide visitSharedVariable: self! !

CMVariable subclass: #CMPoolImport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMPoolImport methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:59'!
acceptGuide: aGuide
	aGuide visitPoolImport: self! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/15/2004 22:55'!
isInstanceVariable
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:32'!
isSequence
	^ false! !

!CMNode methodsFor: 'accessing' stamp: 'cwp 5/20/2004 19:24'!
parent
	^ parent! !

Object subclass: #CMVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:10'!
visitToken: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:39'!
visitSharedVariable: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitBlock: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 14:23'!
visitArgument: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitReturn: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/26/2004 15:03'!
visitAnnotation: aNode
	self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitInstanceVariable: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitMessage: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitCascade: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitPoolImport: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitLiteral: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:27'!
visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitMethod: aNode
	^ self visitNode: aNode! !

CMVisitor subclass: #CMSourcePrinter
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

!CMSourcePrinter class methodsFor: 'printing' stamp: 'cwp 5/25/2004 00:34'!
print: aNode on: aStream
	| printer |
	printer _ self new.
	printer stream: aStream.
	printer print: aNode! !

!CMSourcePrinter methodsFor: 'printing' stamp: 'cwp 5/25/2004 02:13'!
print: aNode 
	CMTokenGuide guide: self through: aNode.
! !

!CMSourcePrinter methodsFor: 'visiting' stamp: 'cwp 5/25/2004 02:14'!
visitToken: aToken
	stream nextPutAll: aToken whitespace.
	stream nextPutAll: aToken value! !

!CMSourcePrinter methodsFor: 'accessing' stamp: 'cwp 5/25/2004 00:35'!
stream: aStream
	stream _ aStream! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:39'!
visitVariableReference: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitArray: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitPackage: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitAssignment: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitClass: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitSequence: aNode
	^ self visitNode: aNode! !

TestCase subclass: #CMPackageMirrorTest
	instanceVariableNames: 'info mirror'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMPackageMirrorTest methodsFor: 'running' stamp: 'cwp 5/26/2004 16:33'!
setUp
	info _ PackageInfo hidden: 'Bogus'.
	mirror _ CMPackageMirror forInfo: info.
	! !

!CMPackageMirrorTest methodsFor: 'testing' stamp: 'cwp 5/26/2004 16:44'!
testCoreClasses
	self assert: mirror classes = info classes! !

!CMPackageMirrorTest methodsFor: 'testing' stamp: 'cwp 5/26/2004 16:37'!
testName
	self assert: mirror packageName = info packageName! !

!CMPackageMirrorTest methodsFor: 'testing' stamp: 'cwp 5/26/2004 19:46'!
testMethods
	| expected actual |
	expected _ info methods.
	actual _ mirror methods.
	self assert: actual size = expected size.
	self assert: (actual includesAllOf: expected)! !

TestCase subclass: #CMPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMPrinterTest methodsFor: 'methods' stamp: 'cwp 5/25/2004 02:24'!
testComment
	self assertMethodMatches: 'foo "this is a comment" ^ 1'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 15:29'!
testBlockWithTemps
	self assertExpressionMatches: ' [:a : b :c || foo bar | foo]'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 13:16'!
testArray
	self assertExpressionMatches: ' {foo. var. brz}'! !

!CMPrinterTest methodsFor: 'asserting' stamp: 'cwp 5/25/2004 02:38'!
assertTree: root matches: source
	| stream result |
	stream _ WriteStream on: (String new: source size).
	CMSourcePrinter print: root on: stream.
	result _ stream contents.
	self assert: result = source.! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 16:00'!
testAssignment1
	self assertExpressionMatches: 'foo _ bar'! !

!CMPrinterTest methodsFor: 'asserting' stamp: 'cwp 5/26/2004 15:15'!
assertAnnotationMatches: source
	| stream result |
	stream _ WriteStream on: (String new: source size).
	(CMParser parseAnnotations: source)
		do: [:ea | CMSourcePrinter print: ea on: stream].
	result _ stream contents.
	self assert: result = source.! !

!CMPrinterTest methodsFor: 'methods' stamp: 'cwp 5/25/2004 15:31'!
testKeywordMethod
	self assertMethodMatches: 'foo: one bar: two ^ two'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 16:04'!
testLiteral
	self assertExpressionMatches: '''foo'''! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 16:00'!
testAssignment2
	self assertExpressionMatches: 'foo := bar'! !

!CMPrinterTest methodsFor: 'asserting' stamp: 'cwp 5/25/2004 00:29'!
assertMethodMatches: source
	self assertTree: (CMParser parseMethod: source) matches: source
! !

!CMPrinterTest methodsFor: 'annotations' stamp: 'cwp 5/26/2004 15:16'!
testMulitpleAnnotations
	self assertAnnotationMatches: '<primitive: 1> <primitive: 2>'! !

!CMPrinterTest methodsFor: 'methods' stamp: 'cwp 5/26/2004 12:20'!
testUnaryMethod
	self assertMethodMatches: 'foo ^ 1'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 16:02'!
testByteArray
	self assertExpressionMatches: '#[10 13]'! !

!CMPrinterTest methodsFor: 'annotations' stamp: 'cwp 5/26/2004 15:00'!
testPrimitive
	self assertAnnotationMatches: '<primitive: 1>'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 13:39'!
testBlock
	self assertExpressionMatches: ' [foo bar. baz]'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 15:58'!
testCascade
	self assertExpressionMatches: 'foo bar; baz'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 02:29'!
testMessages
	self assertExpressionMatches: 'foo bar. blic razz: 3 zap: 4. zic + 2'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 13:53'!
testBlockArgs
	self assertExpressionMatches: ' [:a :b :c]'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 19:35'!
testParenthesis3
	self assertExpressionMatches: '(foo _ 1) bar'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 02:23'!
testReturn
	self assertMethodMatches: 'foo ^ 1'! !

!CMPrinterTest methodsFor: 'asserting' stamp: 'cwp 5/25/2004 00:30'!
assertExpressionMatches: source
	self assertTree: (CMParser parseExpression: source) matches: source
! !

!CMPrinterTest methodsFor: 'methods' stamp: 'cwp 5/25/2004 02:24'!
testTemps
	self assertMethodMatches: 'foo | glaz blech | ^ 1'! !

!CMPrinterTest methodsFor: 'annotations' stamp: 'cwp 5/26/2004 15:12'!
testMultikeywordAnnotation
	self assertAnnotationMatches: '<primitive: ''foo'' module: ''bar''>'! !

!CMPrinterTest methodsFor: 'methods' stamp: 'cwp 5/26/2004 12:21'!
testBinaryMethod
	self assertMethodMatches: '+ other ^ 1'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 15:54'!
testParenthesis2
	self assertExpressionMatches: '([self doSomething] on: Error do: []) bar'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 16:02'!
testLiteralArray
	self assertExpressionMatches: '#(foo bar 1 2)'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 14:47'!
testBlockWithArgs
	self assertExpressionMatches: ' [:a :b :c | self so: a by: b see: c]'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 15:33'!
testParenthesis
	self assertExpressionMatches: '(self foo: 1) bar'! !

TestCase subclass: #CMParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:26'!
testNilLiteral
	self assertLiteralParses: nil! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:22'!
testBinaryMessage
	| root message |
	root _ self parseExpression: '3 + 4'.
	message _ root statements first.
	self assert: message isMessage.
	self assert: message receiver isLiteral.
	self assert: message selector = #+.
	self assert: message arguments first isLiteral.! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:23'!
testBlockWithArguments
	| root |
	root _ self parseExpression: '[:foo :bar | self doSomething]'.
	self assert: root isSequence.
	self assert: root statements first isBlock.
	self assert: root statements first body isSequence.
	root statements first arguments 
						with: #(foo bar)
						do: [:arg :name | 
							self assert: arg isArgument.
							self assert: arg name = name]
							
! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:26'!
testReturnWithStatements
	| root |
	root _ self parseExpression: 'self foo. self bar. ^ 1'.
	self assert: root isSequence.
	self assert: root statements third isReturn.
	self assert: root statements third value isLiteral.
	self assert: root statements third value value = 1.! !

!CMParserTest methodsFor: 'parsing' stamp: 'cwp 5/28/2004 06:32'!
parse: aString with: aSelector
	self 
		shouldnt: [^ self parser perform: aSelector with: aString] 
		raise: SmaCCParserError.! !

!CMParserTest methodsFor: 'parsing' stamp: 'cwp 5/28/2004 06:31'!
parseAnnotations: aString
	^ self parse: aString with: #parseAnnotations:! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:22'!
testBareReturn
	| root |
	root _ self parseExpression: '^ 1'.
	self assert: root isSequence.
	self assert: root statements first isReturn.
	self assert: root statements first value isLiteral.
	self assert: root statements first value value = 1.! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:26'!
testSymbolLiteral
	| root |
	root _ self parseExpression: '#foo'.
	self assertLiteralExpression: root equals: #foo! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:41'!
testFalseLiteral
	self assertLiteralParses: false! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:25'!
testKeywordMessage
	| root message |
	root _ self parseExpression: 'self add: 4 to: 4'.
	message _ root statements first.
	self assert: message isMessage.
	self assert: message receiver isVariableReference.
	self assert: message selector = #add:to:.
	self assert: message arguments first isLiteral.
	self assert: message arguments second isLiteral.! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:25'!
testMethodWithTempsAndPrimitive2
	| root |
	root _ self parseMethod: '+ aNumber <primitive: 1> | foo bar |  ^ foo + bar'.
	self assert: root isMethod.
	self assert: root annotations first isAnnotation.
	! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:23'!
testBlockWithTemps2
	| root |
	root _ self parseExpression: '[:foo :bar || baz quux | self doSomething]'.
	self assert: root isSequence.
	self assert: root statements first isBlock.
	self assert: root statements first body isSequence.
	root statements first body temporaries 
						with: #(baz quux)
						do: [:arg :name | 
							self assert: arg isVariableReference.
							self assert: arg name = name]
							
! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:24'!
testGreaterThan
	"Test for potential conflict with annotation syntax"

	| root message |
	root _ self parseExpression: '3 > 4'.
	message _ root statements first.
	self assert: message isMessage.
	self assert: message receiver isLiteral.
	self assert: message selector = #>.
	self assert: message arguments first isLiteral.! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:24'!
testCharacterLiteral
	| root |
	root _ self parseExpression: '$g'.
	self assertLiteralExpression: root equals: $g! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:26'!
testMultiKeywordSymbolLiteral
	| root |
	root _ self parseExpression: '#foo:bar:'.
	self assertLiteralExpression: root equals: #foo:bar:! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:25'!
testKeywordMethod
	| root |
	root _ self parseMethod: 'foo: anObject bar: object'.
	self assert: root isMethod.
	self assert: root selector = #foo:bar:! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:25'!
testLessThan
	"Test for potential conflict with annotation syntax"

	| root message |
	root _ self parseExpression: '3 < 4'.
	message _ root statements first.
	self assert: message isMessage.
	self assert: message receiver isLiteral.
	self assert: message selector = #<.
	self assert: message arguments first isLiteral.! !

!CMParserTest methodsFor: 'parsing' stamp: 'cwp 5/28/2004 06:31'!
parseExpression: aString
	^ self parse: aString with: #parseExpression:! !

!CMParserTest methodsFor: 'asserting' stamp: 'cwp 5/24/2004 14:38'!
assertLiteralExpression: root equals: value
	self assert: root isSequence.
	self assert: root statements first isLiteral.
	self assert: root statements first value = value
! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:42'!
testNegativeNumberLiteral
	self assertLiteralParses: -13! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:41'!
testArrayLiteral
	self assertLiteralParses: #(1 2 3)! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:24'!
testByteArrayLiteral
	| root |
	root _ self parseExpression: '#[1 2 3]'.
	self assertLiteralExpression: root equals: (ByteArray with: 1 with: 2 with: 3)! !

!CMParserTest methodsFor: 'parsing' stamp: 'cwp 5/28/2004 06:31'!
parseMethod: aString
	^ self parse: aString with: #parseMethod:! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:25'!
testMultiKeywordPrim
	| prim |
	prim _ (self parseAnnotations: '<primitive: ''foo'' module: ''FooModule''>') first.
	self assert: prim selector = #primitive:module:.
	self assert: (prim arguments collect: [:ea | ea value]) = #('foo' 'FooModule').
	self assert: prim isAnnotation! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:25'!
testMethodWithPrimitive
	| root |
	root _ self parseMethod: '+ aNumber <primitive: 1> ^ super + aNumber'.
	self assert: root isMethod.
	self assert: root annotations first isAnnotation.
	self assert: root annotations first selector = #primitive:.
	self assert: root annotations first arguments first isLiteral.
	self assert: root annotations first arguments first value = 1.
	! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:27'!
testUnaryMethod
	| root |
	root _ self parseMethod: 'foo'.
	self assert: root isMethod.
	self assert: root selector = #foo! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:26'!
testStringSymbolLiteral
	| root |
	root _ self parseExpression: '#''foo bar'''.
	self assertLiteralExpression: root equals: #'foo bar'! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:41'!
testTrueLiteral
	self assertLiteralParses: true! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:24'!
testExpressionWithTemps
	| root |
	root _ self parseExpression: '| foo bar | foo _ 2. bar _ 3. foo + bar'.
	self assert: root isSequence.
	root temporaries with: #(foo bar) do: [:temp :name |
						self assert: (temp isVariableReference).
						self assert: (name = temp name)].
	self assert: root leftBar isToken.
	self assert: root leftBar value = '|'.
	self assert: root rightBar isToken.
	self assert: root rightBar value = '|'.
	! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:22'!
testAssignment
	| root |
	root _ self parseExpression: 'var _ #value'.
	self assert: root statements first isAssignment.
	self assert: root statements first variable isVariableReference.
	self assert: root statements first value isValue.! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/24/2004 15:32'!
testNestedArrayLiteral
	self assertLiteralParses: #(1 2 (3 4 5))! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:21'!
testArray
	| root |
	root _ self parseExpression: '{1. self foo. 2}'.
	self assert: root statements first isArray.
	self assert: root statements first statements first isLiteral.
	self assert: root statements first statements second isMessage.
	self assert: root statements first statements third isLiteral.! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:24'!
testCascade
	| root cascade |
	root _ self parseExpression: 'self foo; bar'.
	cascade _ root statements first.
	self assert: cascade isCascade.
	self assert: cascade messages first selector = #foo.
	self assert: cascade messages second selector = #bar.! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:27'!
testUnaryMessage
	| root message |
	root _ self parseExpression: 'self foo'.
	message _ root statements first.
	self assert: message isMessage.
	self assert: message receiver isVariableReference.
	self assert: message selector = #foo.! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:25'!
testMethodWithTempsAndPrimitive
	| root |
	root _ self parseMethod: '+ aNumber | foo bar | <primitive: 1> ^ foo + bar'.
	self assert: root isMethod.
	self assert: root annotations first isAnnotation.
	! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:24'!
testCascade2
	| root cascade |
	root _ self parseExpression: 'self foo; bar; baz'.
	cascade _ root statements first.
	self assert: cascade isCascade.
	self assert: cascade messages first selector = #foo.
	self assert: cascade messages second selector = #bar.! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:23'!
testBinarySymbolLiteral
	| root |
	root _ self parseExpression: '#+'.
	self assertLiteralExpression: root equals: #+! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:23'!
testBlockWithTemps
	| root |
	root _ self parseExpression: '[:foo :bar | | baz quux | self doSomething]'.
	self assert: root isSequence.
	self assert: root statements first isBlock.
	self assert: root statements first body isSequence.
	root statements first body temporaries 
						with: #(baz quux)
						do: [:arg :name | 
							self assert: arg isVariableReference.
							self assert: arg name = name]
							
! !

!CMParserTest methodsFor: 'asserting' stamp: 'cwp 5/28/2004 06:22'!
assertLiteralParses: value
	| root |
	root _ self parseExpression: value asString.
	self assertLiteralExpression: root equals: value! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:26'!
testMultiPrim
	| prims |
	prims _ self parseAnnotations: '<primitive: 1> <primitive: 2>'.
	self assert: prims first isAnnotation.
	self assert: prims second isAnnotation.! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:26'!
testStringLiteral
	| root |
	root _ self parseExpression: '''foo'''.
	self assertLiteralExpression: root equals: 'foo'! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:23'!
testBlock
	| root |
	root _ self parseExpression: '[self doSomething]'.
	self assert: root isSequence.
	self assert: root statements first isBlock..
! !

!CMParserTest methodsFor: 'parsing' stamp: 'cwp 5/28/2004 06:18'!
parser
	^ CMParser! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:23'!
testBinaryMethod
	| root |
	root _ self parseMethod: '+ other'.
	self assert: root isMethod.
	self assert: root selector = #+! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/28/2004 06:25'!
testKeywordSymbolLiteral
	| root |
	root _ self parseExpression: '#foo:'.
	self assertLiteralExpression: root equals: #foo:! !

!CMParserTest methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:42'!
testNumberLiteral
	self assertLiteralParses: 13! !

TestCase subclass: #CMImporterTest
	instanceVariableNames: 'package methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMImporterTest methodsFor: 'testing' stamp: 'cwp 5/27/2004 16:46'!
testInstanceVariables
	| ivars class |
	class _ package classes second.
	ivars _ class instanceVariables.
	self assert: ivars first name = #firstInstanceVariableB.
	self assert: ivars second name = #secondInstanceVariableB.
	self assert: ivars first parent == class.
	self assert: ivars second parent == class.! !

!CMImporterTest methodsFor: 'testing' stamp: 'cwp 5/27/2004 17:03'!
testInstanceMethods
	self 
		assertMethodsFrom: #instanceMethods
		inClass: package classes first
		match: BogusInfo instanceMethodsA! !

!CMImporterTest methodsFor: 'testing' stamp: 'cwp 5/27/2004 16:48'!
testClassVariables
	| cvars class |
	class _ package classes second.
	cvars _ class classVariables.
	self assert: cvars first name = #FirstClassVariableB.
	self assert: cvars second name = #SecondClassVariableB.
	self assert: cvars first parent == class.
	self assert: cvars second parent == class.! !

!CMImporterTest methodsFor: 'running' stamp: 'cwp 5/20/2004 17:04'!
setUp
	package _ CMPackageImporter import: 'Bogus'! !

!CMImporterTest methodsFor: 'testing' stamp: 'cwp 5/20/2004 19:23'!
testClasses
	package classes 
				with: BogusInfo classes 
				do: [:node :class | 
					self assert: (node refersTo: class).
					self assert: node parent == package]
	! !

!CMImporterTest methodsFor: 'asserting' stamp: 'cwp 5/27/2004 17:01'!
assertMethodsFrom: selector inClass: class match: expected
	methods _ (class perform: selector) asArray sort: [:x :y | x selector <= y selector].
	methods do: [:ea | self assert: ea parent = class].
	self assert: (methods collect: [:ea | ea selector]) = expected
! !

!CMImporterTest methodsFor: 'testing' stamp: 'cwp 5/27/2004 16:49'!
testPoolImports
	| pool class |
	class _ package classes second.
	pool _ class poolImports first.
	self assert: pool name = #BogusPool.
	self assert: pool parent == class.! !

!CMImporterTest methodsFor: 'testing' stamp: 'cwp 5/27/2004 16:51'!
testClassInstVariables
	| civars class |
	class _ package classes second.
	civars _ class classInstanceVariables.
	self assert: civars first name = #firstClassInstanceVariableB.
	self assert: civars second name = #secondClassInstanceVariableB.
	self assert: civars first parent == class.
	self assert: civars second parent == class! !

!CMImporterTest methodsFor: 'testing' stamp: 'cwp 5/27/2004 17:03'!
testClassMethods
	self 
		assertMethodsFrom: #classMethods
		inClass: package classes first
		match: BogusInfo classMethodsA! !
